// WinGL - Windows Game class Library L1
//  version 0.11d
//   Copyright (C)1995-96 A.Koizuka, alty
//

#if defined(_MSC_VER) && _MSC_VER >= 900
# pragma warning(disable : 4201 4115 4214)
#endif
#include <windows.h>
#include "WinGL.h"
#include "game.h"
#if defined(_MSC_VER) && _MSC_VER >= 900
# pragma warning(default : 4201 4115 4214)
#endif
#ifdef _MSC_VER
# if WINGL16
#  pragma comment(lib,"MMSYSTEM")
# else
#  pragma comment(lib,"WINMM")
# endif
#endif

#define MESSAGE_OUT 0 /* bZ[W̃fobOo̓tO */

GApp * MainApp ;
GWindow * GWindow::creatingWindow ;
extern "C" BOOL __WinGLNoSelectPalette;

//
// GApp Implementation
//

BOOL CALLBACK EXPORT GApp::AboutProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM ) {
	switch (msg) {
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK) {
				EndDialog(hwnd,TRUE);
		}
		break;
	case WM_INITDIALOG:
		return TRUE;
	}
	return FALSE;
}

void GApp::OnMainWindowDestroy() {
	PostQuitMessage(0);
}

#if MESSAGE_OUT
static struct mest {
	UINT msg;
	char * str;
} mestable[] = {
WM_NULL,                  "WM_NULL",
WM_CREATE,                "WM_CREATE",
WM_DESTROY,               "WM_DESTROY",
WM_MOVE,                  "WM_MOVE",
WM_SIZE,                  "WM_SIZE",
WM_ACTIVATE,              "WM_ACTIVATE",
WM_SETFOCUS,              "WM_SETFOCUS",
WM_KILLFOCUS,             "WM_KILLFOCUS",
WM_ENABLE,                "WM_ENABLE",
WM_SETREDRAW,             "WM_SETREDRAW",
WM_SETTEXT,               "WM_SETTEXT",
WM_GETTEXT,               "WM_GETTEXT",
WM_GETTEXTLENGTH,         "WM_GETTEXTLENGTH",
WM_PAINT,                 "WM_PAINT",
WM_CLOSE,                 "WM_CLOSE",
WM_QUERYENDSESSION,       "WM_QUERYENDSESSION",
WM_QUIT ,                 "WM_QUIT",
WM_QUERYOPEN,             "WM_QUERYOPEN",
WM_ERASEBKGND,            "WM_ERASEBKGND",
WM_SYSCOLORCHANGE,        "WM_SYSCOLORCHANGE",
WM_ENDSESSION,            "WM_ENDSESSION",
WM_SHOWWINDOW,            "WM_SHOWWINDOW",
WM_WININICHANGE,          "WM_WININICHANGE",
#ifdef WM_SETTINGCHANGE
WM_SETTINGCHANGE,         "WM_SETTINGCHANGE",
#endif
WM_DEVMODECHANGE,         "WM_DEVMODECHANGE",
WM_ACTIVATEAPP,           "WM_ACTIVATEAPP",
WM_FONTCHANGE,            "WM_FONTCHANGE",
WM_TIMECHANGE,            "WM_TIMECHANGE",
WM_CANCELMODE,            "WM_CANCELMODE",
WM_SETCURSOR,             "WM_SETCURSOR",
WM_MOUSEACTIVATE,         "WM_MOUSEACTIVATE",
WM_CHILDACTIVATE,         "WM_CHILDACTIVATE",
WM_QUEUESYNC,             "WM_QUEUESYNC",
WM_GETMINMAXINFO,         "WM_GETMINMAXINFO",
WM_PAINTICON,             "WM_PAINTICON",
WM_ICONERASEBKGND,        "WM_ICONERASEBKGND",
WM_NEXTDLGCTL,            "WM_NEXTDLGCTL",
WM_SPOOLERSTATUS,         "WM_SPOOLERSTATUS",
WM_DRAWITEM,              "WM_DRAWITEM",
WM_MEASUREITEM,           "WM_MEASUREITEM",
WM_DELETEITEM,            "WM_DELETEITEM",
WM_VKEYTOITEM,            "WM_VKEYTOITEM",
WM_CHARTOITEM,            "WM_CHARTOITEM",
WM_SETFONT,               "WM_SETFONT",
WM_GETFONT,               "WM_GETFONT",
WM_SETHOTKEY,             "WM_SETHOTKEY",
WM_GETHOTKEY,             "WM_GETHOTKEY",
WM_QUERYDRAGICON,         "WM_QUERYDRAGICON",
WM_COMPAREITEM,           "WM_COMPAREITEM",
WM_COMPACTING,            "WM_COMPACTING",
WM_COMMNOTIFY,            "WM_COMMNOTIFY",
WM_WINDOWPOSCHANGING,     "WM_WINDOWPOSCHANGING",
WM_WINDOWPOSCHANGED,      "WM_WINDOWPOSCHANGED",
WM_POWER    ,             "WM_POWER",
WM_COPYDATA  ,            "WM_COPYDATA",
WM_CANCELJOURNAL,         "WM_CANCELJOURNAL",
#ifdef WM_NOTIFY
WM_NOTIFY,                "WM_NOTIFY",
#endif
WM_INPUTLANGCHANGEREQUEST,"WM_INPUTLANGCHANGEREQUEST",
WM_INPUTLANGCHANGE,       "WM_INPUTLANGCHANGE",
WM_TCARD,                 "WM_TCARD",
WM_HELP,                  "WM_HELP",
WM_USERCHANGED,           "WM_USERCHANGED",
WM_NOTIFYFORMAT,          "WM_NOTIFYFORMAT",
WM_CONTEXTMENU,           "WM_CONTEXTMENU",
WM_STYLECHANGING,         "WM_STYLECHANGING",
WM_STYLECHANGED,          "WM_STYLECHANGED",
WM_DISPLAYCHANGE,         "WM_DISPLAYCHANGE",
WM_GETICON   ,            "WM_GETICON",
WM_SETICON,               "WM_SETICON",
WM_NCCREATE,              "WM_NCCREATE",
WM_NCDESTROY,             "WM_NCDESTROY",
WM_NCCALCSIZE,            "WM_NCCALCSIZE",
WM_NCHITTEST,             "WM_NCHITTEST",
WM_NCPAINT,               "WM_NCPAINT",
WM_NCACTIVATE,            "WM_NCACTIVATE",
WM_GETDLGCODE,            "WM_GETDLGCODE",
WM_NCMOUSEMOVE,           "WM_NCMOUSEMOVE",
WM_NCLBUTTONDOWN,         "WM_NCLBUTTONDOWN",
WM_NCLBUTTONUP,           "WM_NCLBUTTONUP",
WM_NCLBUTTONDBLCLK,       "WM_NCLBUTTONDBLCLK",
WM_NCRBUTTONDOWN,         "WM_NCRBUTTONDOWN",
WM_NCRBUTTONUP,           "WM_NCRBUTTONUP",
WM_NCRBUTTONDBLCLK,       "WM_NCRBUTTONDBLCLK",
WM_NCMBUTTONDOWN,         "WM_NCMBUTTONDOWN",
WM_NCMBUTTONUP,           "WM_NCMBUTTONUP",
WM_NCMBUTTONDBLCLK,       "WM_NCMBUTTONDBLCLK",
WM_KEYFIRST,              "WM_KEYFIRST",
WM_KEYDOWN,               "WM_KEYDOWN",
WM_KEYUP,                 "WM_KEYUP",
WM_CHAR,                  "WM_CHAR",
WM_DEADCHAR,              "WM_DEADCHAR",
WM_SYSKEYDOWN,            "WM_SYSKEYDOWN",
WM_SYSKEYUP,              "WM_SYSKEYUP",
WM_SYSCHAR ,              "WM_SYSCHAR",
WM_SYSDEADCHAR,           "WM_SYSDEADCHAR",
WM_KEYLAST,               "WM_KEYLAST",
WM_IME_STARTCOMPOSITION,  "WM_IME_STARTCOMPOSITION",
WM_IME_ENDCOMPOSITION,    "WM_IME_ENDCOMPOSITION",
WM_IME_COMPOSITION,       "WM_IME_COMPOSITION",
WM_IME_KEYLAST,           "WM_IME_KEYLAST",
WM_INITDIALOG,            "WM_INITDIALOG",
WM_COMMAND,               "WM_COMMAND",
WM_SYSCOMMAND,            "WM_SYSCOMMAND",
WM_TIMER,                 "WM_TIMER",
WM_HSCROLL,               "WM_HSCROLL",
WM_VSCROLL,               "WM_VSCROLL",
WM_INITMENU,              "WM_INITMENU",
WM_INITMENUPOPUP,         "WM_INITMENUPOPUP",
WM_MENUSELECT,            "WM_MENUSELECT",
WM_MENUCHAR,              "WM_MENUCHAR",
WM_ENTERIDLE,             "WM_ENTERIDLE",
WM_CTLCOLORMSGBOX,        "WM_CTLCOLORMSGBOX",
WM_CTLCOLOREDIT,          "WM_CTLCOLOREDIT",
WM_CTLCOLORLISTBOX,       "WM_CTLCOLORLISTBOX",
WM_CTLCOLORBTN,           "WM_CTLCOLORBTN",
WM_CTLCOLORDLG,           "WM_CTLCOLORDLG",
WM_CTLCOLORSCROLLBAR,     "WM_CTLCOLORSCROLLBAR",
WM_CTLCOLORSTATIC,        "WM_CTLCOLORSTATIC",
WM_MOUSEFIRST,            "WM_MOUSEFIRST",
WM_MOUSEMOVE,             "WM_MOUSEMOVE",
WM_LBUTTONDOWN,           "WM_LBUTTONDOWN",
WM_LBUTTONUP,             "WM_LBUTTONUP",
WM_LBUTTONDBLCLK,         "WM_LBUTTONDBLCLK",
WM_RBUTTONDOWN,           "WM_RBUTTONDOWN",
WM_RBUTTONUP,             "WM_RBUTTONUP",
WM_RBUTTONDBLCLK,         "WM_RBUTTONDBLCLK",
WM_MBUTTONDOWN,           "WM_MBUTTONDOWN",
WM_MBUTTONUP,             "WM_MBUTTONUP",
WM_MBUTTONDBLCLK,         "WM_MBUTTONDBLCLK",
WM_MOUSELAST,             "WM_MOUSELAST",
WM_PARENTNOTIFY,          "WM_PARENTNOTIFY",
WM_ENTERMENULOOP,         "WM_ENTERMENULOOP",
WM_EXITMENULOOP,          "WM_EXITMENULOOP",
WM_NEXTMENU,              "WM_NEXTMENU",
WM_SIZING,                "WM_SIZING",
WM_CAPTURECHANGED,        "WM_CAPTURECHANGED",
WM_MOVING,                "WM_MOVING",
WM_POWERBROADCAST,        "WM_POWERBROADCAST",
WM_DEVICECHANGE,          "WM_DEVICECHANGE",
WM_IME_SETCONTEXT,        "WM_IME_SETCONTEXT",
WM_IME_NOTIFY,            "WM_IME_NOTIFY",
WM_IME_CONTROL,           "WM_IME_CONTROL",
WM_IME_COMPOSITIONFULL,   "WM_IME_COMPOSITIONFULL",
WM_IME_SELECT,            "WM_IME_SELECT",
WM_IME_CHAR,              "WM_IME_CHAR",
WM_IME_KEYDOWN,           "WM_IME_KEYDOWN",
WM_IME_KEYUP,             "WM_IME_KEYUP",
WM_MDICREATE,             "WM_MDICREATE",
WM_MDIDESTROY,            "WM_MDIDESTROY",
WM_MDIACTIVATE,           "WM_MDIACTIVATE",
WM_MDIRESTORE,            "WM_MDIRESTORE",
WM_MDINEXT,               "WM_MDINEXT",
WM_MDIMAXIMIZE,           "WM_MDIMAXIMIZE",
WM_MDITILE,               "WM_MDITILE",
WM_MDICASCADE,            "WM_MDICASCADE",
WM_MDIICONARRANGE,        "WM_MDIICONARRANGE",
WM_MDIGETACTIVE,          "WM_MDIGETACTIVE",
WM_MDISETMENU,            "WM_MDISETMENU",
WM_ENTERSIZEMOVE,         "WM_ENTERSIZEMOVE",
WM_EXITSIZEMOVE,          "WM_EXITSIZEMOVE",
WM_DROPFILES,             "WM_DROPFILES",
WM_MDIREFRESHMENU,        "WM_MDIREFRESHMENU",
WM_CUT,                   "WM_CUT",
WM_COPY,                  "WM_COPY",
WM_PASTE,                 "WM_PASTE",
WM_CLEAR,                 "WM_CLEAR",
WM_UNDO,                  "WM_UNDO",
WM_RENDERFORMAT,          "WM_RENDERFORMAT",
WM_RENDERALLFORMATS,      "WM_RENDERALLFORMATS",
WM_DESTROYCLIPBOARD,      "WM_DESTROYCLIPBOARD",
WM_DRAWCLIPBOARD,         "WM_DRAWCLIPBOARD",
WM_PAINTCLIPBOARD,        "WM_PAINTCLIPBOARD",
WM_VSCROLLCLIPBOARD,      "WM_VSCROLLCLIPBOARD",
WM_SIZECLIPBOARD,         "WM_SIZECLIPBOARD",
WM_ASKCBFORMATNAME,       "WM_ASKCBFORMATNAME",
WM_CHANGECBCHAIN,         "WM_CHANGECBCHAIN",
WM_HSCROLLCLIPBOARD,      "WM_HSCROLLCLIPBOARD",
WM_QUERYNEWPALETTE,       "WM_QUERYNEWPALETTE",
WM_PALETTEISCHANGING,     "WM_PALETTEISCHANGING",
WM_PALETTECHANGED,        "WM_PALETTECHANGED",
WM_HOTKEY,                "WM_HOTKEY",
WM_PRINT,                 "WM_PRINT",
WM_PRINTCLIENT,           "WM_PRINTCLIENT",
WM_HANDHELDFIRST,         "WM_HANDHELDFIRST",
WM_HANDHELDLAST,          "WM_HANDHELDLAST",
WM_AFXFIRST,              "WM_AFXFIRST",
WM_AFXLAST,               "WM_AFXLAST",
WM_PENWINFIRST,           "WM_PENWINFIRST",
WM_PENWINLAST,            "WM_PENWINLAST",
WM_APP,                   "WM_APP",
WM_USER,                  "WM_USER",
};

static
void message_out( UINT msg, WPARAM wparam, LPARAM lparam ) {
	char s[80];
	char * p;
	int i;
	p = "?";
	for ( i = 0 ; i < (sizeof mestable) / (sizeof mestable[0]) ; ++i ) {
		if ( mestable[i].msg == msg ) {
			p = mestable[i].str;
			break;
		}
	}
	wsprintf(s, "m=0x%04x(%s), w=%08x, l=%08x\n", msg,p,wparam,lparam);
	OutputDebugString(s);
	if ( msg == WM_WINDOWPOSCHANGING || msg == WM_WINDOWPOSCHANGED ) {
		LPWINDOWPOS wp = (LPWINDOWPOS)lparam;
		wsprintf(s, "  (x=%d,y=%d,cx=%d,cy=%d,flags=%08x)\n", 
			wp->x,wp->y,wp->cx,wp->cy,wp->flags );
		OutputDebugString(s);
	} else if ( msg == WM_WININICHANGE ) {
		wsprintf(s, "  (%s)\n", (LPCTSTR)lparam );
		OutputDebugString(s);
	}
}
#endif


//
// GWindow Implementation
//

LRESULT GWindow::Dispatch() {
	PAINTSTRUCT ps;
	HDC hdc;
	BOOL f;
	UINT fuFlags ;
	HMENU hmenu ;
	LRESULT l;
#if MESSAGE_OUT == 1
	message_out(msg,wparam,lparam);
#endif
	switch ( msg ) {
	case WM_CREATE :
		return 0;

	case WM_DESTROY:
		OnDestroy();
		if ( MainApp && MainApp->GetMainWindow() == this ) {
			MainApp->OnMainWindowDestroy();
		}
		return 0;

	case WM_NCDESTROY:
		l = DefWindowProc(hwnd,msg,wparam,lparam);
		hwnd = 0;
		return l;
#if 1
	case WM_ACTIVATEAPP:
		OnActivate( (BOOL)wparam ) ;
		return 0;
#endif
#if 1
	case WM_NCACTIVATE:
		l = DefWindowProc(hwnd,msg,wparam,lparam);
		OnActivate( (BOOL)wparam ) ;
		return l;
#endif

	case WM_ENABLE:
		OnEnable( (BOOL)wparam ) ;
		return 0;

	case WM_GETMINMAXINFO :
		OnMinMaxInfo( (MINMAXINFO FAR *)lparam ) ;
		return 0;

	case WM_WINDOWPOSCHANGING :
		return OnWindowPosChanging( (LPWINDOWPOS) lparam ) ;

	case WM_SIZE:
		return OnSize();

#ifndef WM_ENTERSIZEMOVE
# define WM_ENTERSIZEMOVE 0x231
# define WM_EXITSIZEMOVE  0x232
#endif
	case WM_ENTERSIZEMOVE:
		bFulldragging = TRUE;
		OnEnterSizeMove();
		return 0;

	case WM_EXITSIZEMOVE:
		bFulldragging = FALSE;
		OnExitSizeMove();
		return 0;

	case WM_SYSCOMMAND:
		if ( wparam >= 0xf000 )
			break;   // pass to DefWindowProc()

		if ( wparam == SC_RESTORE ) {
			OnSysRestored();
			break;
		}

		// fall through to WM_COMMAND

	case WM_COMMAND:
#if WINGL32
		return OnCommand(HIWORD(wparam),LOWORD(wparam),(HWND)lparam) ;
#else
		return OnCommand(HIWORD(lparam),LOWORD(wparam),(HWND)lparam) ;
#endif

	case WM_CLOSE:
		break;

	case WM_KEYDOWN:
		OnKeyDown( (int)wparam, lparam ) ;
		return 0;

	case WM_KEYUP:
		OnKeyUp( (int)wparam, lparam ) ;
		return 0;

	case WM_PALETTECHANGED:
		if ((HWND)wparam == hwnd)
			break;

		// fall through to WM_QUERYNEWPALETTE

	case WM_QUERYNEWPALETTE:
		hdc = GetDC();

		if (hpal && !__WinGLNoSelectPalette)
			SelectPalette(hdc, hpal, FALSE);

		f = RealizePalette(hdc);
		ReleaseDC(hdc);

		if (f)
			InvalidateRect(NULL,TRUE);

		return f;

	case WM_PAINT:
		hdc = BeginPaint(hwnd,&ps);
		if ( hpal && !__WinGLNoSelectPalette)
			SelectPalette(hdc, hpal, FALSE);
		RealizePalette(hdc);
		OnPaint(hdc) ;
		EndPaint(hwnd,&ps);
		return 0L;

	case WM_SETCURSOR:
		if ( HIWORD(lparam) == 0 ) {
			// menu open
			OnMenuOpen();
		}
		OnSetCursor();
		break;
	case WM_MENUSELECT:
#if WINGL32
		fuFlags =(UINT)HIWORD(wparam);
		hmenu =(HMENU)lparam;
#else
		fuFlags= LOWORD(lparam);
		hmenu =(HMENU)HIWORD(lparam);
#endif
		if ((UINT)fuFlags == 0xffff && hmenu == 0 ) {
			OnMenuCancel() ;
			// menuɂĈꕔBꂽ̂ŁAȕ`̂߂ɑŜXV
			InvalidateRect(0,0);
		}
		break;

	case WM_LBUTTONDOWN:
		OnLButtonDown( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_LBUTTONUP:
		OnLButtonUp( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_MBUTTONDOWN:
		OnMButtonDown( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_MBUTTONUP:
		OnMButtonUp( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_RBUTTONDOWN:
		OnRButtonDown( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_RBUTTONUP:
		OnRButtonUp( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case WM_MOUSEMOVE:
		OnMouseMove( wparam, LOWORD(lparam), HIWORD(lparam) ) ;
		return 0;

	case MM_MCINOTIFY:
		switch ( wparam ) {
		case MCI_NOTIFY_ABORTED:
			return OnMciAborted(LOWORD(lparam)) ;
		case MCI_NOTIFY_SUCCESSFUL:
			return OnMciSuccessful(LOWORD(lparam)) ;
		case MCI_NOTIFY_SUPERSEDED:
			return OnMciSuperseded(LOWORD(lparam)) ;
		case MCI_NOTIFY_FAILURE:
			return OnMciFailure(LOWORD(lparam)) ;
		}
	}
	return DefWindowProc(hwnd,msg,wparam,lparam);
}

void GWindow::OnSysRestored() {}
void GWindow::OnDestroy() {}
LRESULT GWindow::OnCommand(short , short , HWND ) { return DefWindowProc(hwnd,msg,wparam,lparam); }
void GWindow::OnPaint(HDC ) {}
void GWindow::OnMaximized() {}
void GWindow::OnMinimized() {}
void GWindow::OnRestored() {}
LRESULT GWindow::OnWindowPosChanging(LPWINDOWPOS) {return DefWindowProc(hwnd,msg,wparam,lparam); }
void GWindow::OnMinMaxInfo( MINMAXINFO FAR * ) {}
void GWindow::OnActivate(BOOL) {}
void GWindow::OnEnable(BOOL) {}
void GWindow::OnMenuCancel() {}
void GWindow::OnMenuOpen() {}
void GWindow::OnEnterSizeMove() {}
void GWindow::OnExitSizeMove() {}
void GWindow::OnKeyDown( int , DWORD ) {}
#if WINGL32
void GWindow::OnKeyUp( int wVKey, DWORD ) {
	if ( wVKey == VK_SNAPSHOT ) {
		LPWINGL f = WinGLGetFullScreen();
		if ( f && f->hwnd == hwnd ) {
			if ( OpenClipboard( hwnd ) ) {
				WinGLCopyToClipboardDIB( f );
				CloseClipboard();
			}
		}
	}
}
#else
void GWindow::OnKeyUp( int , DWORD ) {}
#endif
void GWindow::OnLButtonDown( WPARAM, WORD, WORD ) {}
void GWindow::OnLButtonUp( WPARAM, WORD, WORD  ) {}
void GWindow::OnMButtonDown( WPARAM, WORD, WORD ) {}
void GWindow::OnMButtonUp( WPARAM, WORD, WORD ) {}
void GWindow::OnRButtonDown( WPARAM, WORD, WORD ) {}
void GWindow::OnRButtonUp( WPARAM, WORD , WORD ) {}
void GWindow::OnMouseMove( WPARAM, WORD , WORD ) {}
void GWindow::OnSetCursor() { DefWindowProc(hwnd,msg,wparam,lparam); }

void GWindow::OnCursorChange() {}
int GWindow::OnMciAborted(WORD) { return 0; }
int GWindow::OnMciSuccessful(WORD) { return 0; }
int GWindow::OnMciSuperseded(WORD) { return 0; }
int GWindow::OnMciFailure(WORD) { return 0; }

LRESULT GWindow::OnSize() {
	switch ( wparam ) {
	case SIZE_MAXIMIZED :
		OnMaximized() ;
		return 0;
	case SIZE_MINIMIZED :
		OnMinimized() ;
		return 0;
	case SIZE_RESTORED :
		OnRestored() ;
		return 0;
	}
	return 0;
}

BOOL GWindow::SetClientSize(unsigned width, unsigned height, BOOL bRepaint, BOOL bForce) {
	RECT rect, crect;
	GetWindowRect(hwnd, &rect) ;
	GetClientRect(hwnd, &crect) ;

	if ( width )
		width += rect.right - rect.left - crect.right ;
	else
		width = rect.right - rect.left ;
	if ( height )
		height += rect.bottom - rect.top - crect.bottom ;
	else
		height = rect.bottom - rect.top ;
	unsigned ScreenWidth = GetSystemMetrics( SM_CXFULLSCREEN );
	unsigned ScreenHeight = GetSystemMetrics( SM_CYFULLSCREEN );
	if ( rect.left + width > ScreenWidth ) {
		rect.left = ScreenWidth - width ;
		if ( rect.left < 0 )
			rect.left = 0;
	}
	if ( rect.top + height > ScreenHeight ) {
		rect.top = ScreenHeight - height ;
		if ( rect.top < 0 )
			rect.top = 0;
	}
	BOOL bOk = ((rect.left + width) <= ScreenWidth && (rect.top + height) <= ScreenHeight );
	if ( bForce  ||  bOk )
		MoveWindow(hwnd, rect.left, rect.top, width, height, bRepaint) ;
	return bOk;
}

LRESULT CALLBACK EXPORT GWindow::AppWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	GWindow * window = GetGWindow(hwnd);
	if ( !window ) {
		window = creatingWindow ;
		creatingWindow = 0;
		window->setHWND(hwnd);
	}

	window->msg = msg ;
	window->wparam = wParam ;
	window->lparam = lParam ;
	return window->Dispatch() ;
}

//
// GGameWindow Implementation
//
HCURSOR GGameWindow::hcsrDefaultNormal;
HCURSOR GGameWindow::hcsrDefaultActive;

void GGameWindow::DrawTitle() {
	char newtitle[256];
	if ( PausebyUser ) {
		wsprintf( newtitle, "%s (Pause)",(LPSTR)title ) ;
	} else if ( PausebyFocus ) {
		wsprintf( newtitle, "%s (Sleep)",(LPSTR)title ) ;
	} else {
		wsprintf( newtitle, "%s",(LPSTR)title ) ;
	}
	SetWindowText(newtitle) ;
}

void GGameWindow::OnSetCursor() {
	HCURSOR hc;
	POINT p;
	GetCursorPos(&p);
	ScreenToClient(getHWND(),&p);
	if ( GetPause() || p.y<0 )
		hc = hcsrNormal ;
	else
		hc = hcsrActive ;
	if ( SetCursor(hc) != hc ) {
		OnCursorChange();
	}
}

void GGameWindow::SetPause( BOOL newPause, BOOL bForce ) {
	BOOL newPauseUser = PausebyUser;
	BOOL newPauseFocus = PausebyFocus;
	if ( bForce )
		newPauseUser = newPause;
	else
		newPauseFocus = newPause;
	if ( newPauseUser != PausebyUser || newPauseFocus != PausebyFocus ) {
		int lastpause = GetPause() ;
		PausebyFocus = newPauseFocus ;
		PausebyUser = newPauseUser ;
		bDirtyCount = FALSE;
		uFrameTime = timeGetTime() ;
		uFrameCount = 0;
		DrawTitle();

		HCURSOR hc;
		if ( newPauseUser || newPauseFocus )
			hc = hcsrNormal;
		else
			hc = hcsrActive;
		if ( SetCursor(hc) != hc ) {
			OnCursorChange();
		}
		OnPause( lastpause );
	}
}

void GGameWindow::OnActivate(BOOL f) {
	if ( !bIcon || !f )
		SetPause( !f, FALSE ) ;
	WinGLAssure(f);
}
void GGameWindow::OnEnable(BOOL f) {
	if ( !bIcon || !f )
		SetPause( !f, FALSE ) ;
}
void GGameWindow::OnMenuOpen() {
	SetPause(TRUE, FALSE) ;
}
void GGameWindow::OnMenuCancel() {
	if ( !bIcon )
		SetPause(FALSE, FALSE) ;
}
void GGameWindow::OnSysRestored() {
	if ( bIcon ) {
		bFulldragging = FALSE;
		bIcon = FALSE;
	}
}
LRESULT GGameWindow::OnSize() {
	if ( wparam == SIZE_MINIMIZED ) {
		bIcon = TRUE;
		SetPause(TRUE,FALSE) ;
	} else if ( bIcon ) {
		bFulldragging = FALSE;
		bIcon = FALSE;
		SetPause(FALSE,FALSE);
	}
	return GWindow::OnSize();
}
void GGameWindow::OnPause(int) {}
BOOL GGameWindow::OnPeriod(HDC,UINT) { return TRUE; }

void GGameWindow::OnExitSizeMove() {
	if ( uPeriodTime ) {
		LONG now = timeGetTime();
		LONG dif = (now - uPeriodNextTime) / uPeriodTime;
		if ( dif > 1 ) {
			uPeriodNextTime += uPeriodTime * dif;
		}
		bDirtyCount = TRUE;
	}
}

void GGameWindow::OnDestroy() {
	if ( MainApp ) {
		MainApp->RemoveIdle( DispatchIdle, (LPVOID)this );
	}
}

BOOL GGameWindow::StartPeriod( UINT milisecond, UINT wmTimerPeriod, BOOL callOnPause) {
	StopPeriod();
	if ( milisecond || wmTimerPeriod == 0 ) {
		bCallOnPause = callOnPause;
		uPeriodTime = milisecond;
		bDirtyCount = TRUE;
		uFrameCount = uLastFrameCount = 0;
		uPeriodCount = 0;
		if ( wmTimerPeriod == 0  &&  MainApp ) {
			uPeriodWMTimer = 0;
			uFrameTime = uPeriodNextTime = uPeriodStartTime = timeGetTime();
			if ( MainApp->AddIdle( DispatchIdle, (LPVOID)this) )
				return TRUE;
		}
		if ( wmTimerPeriod < milisecond )
			wmTimerPeriod = milisecond ;

		idTimer = SetTimer( 0, wmTimerPeriod, (TIMERPROC)DispatchPeriod);
		if ( idTimer ) {
			uPeriodWMTimer = wmTimerPeriod;
			uFrameTime = uPeriodNextTime = uPeriodStartTime = timeGetTime();
			DispatchPeriod(getHWND(),0,0,0);
		}
	}
	return idTimer != 0;
}

void GGameWindow::StopPeriod() {
	if ( idTimer ) {
		KillTimer(idTimer);
		idTimer = 0;
	}
	if ( MainApp ) {
		MainApp->RemoveIdle(DispatchIdle, (LPVOID)this);
	}
	uPeriodTime = 0;
}

void WINGLAPI GGameWindow::DispatchIdle(LPVOID self) {
#if WINGL16 && defined(_MSC_VER)
	GGameWindow * window = (GGameWindow *)(WORD)(DWORD)self;
#else
	GGameWindow * window = (GGameWindow *)self;
#endif
	LONG now = timeGetTime();
	LONG drop;
	HDC hdc;
#if WINGL32
	if ( now < window->uPeriodNextTime ) {
		GdiFlush();
		now = timeGetTime();
		if ( now < window->uPeriodNextTime ) {
			SleepEx( window->uPeriodNextTime - now, TRUE );
			now = timeGetTime();
		}
	}
#endif
	if ( now >= window->uPeriodNextTime ) {
		if ( window->bCallOnPause || !window->GetPause() ) {
			hdc = window->GetDC();
			if ( window->hpal && ! __WinGLNoSelectPalette) {
				SelectPalette(hdc, window->hpal,FALSE);
				RealizePalette(hdc);
			}

			drop = 0;
			if ( window->uPeriodTime ) {
				drop = (now - window->uPeriodNextTime) / window->uPeriodTime ;
				window->uPeriodNextTime += window->uPeriodTime;
			}
			++window->uPeriodCount;
			++window->uFrameCount;
			if ( now - window->uFrameTime >= 1000 ) {
				window->uFrameTime += 1000;
				if ( !window->bDirtyCount ) {
					window->uLastFrameCount = window->uFrameCount;
				}
				window->bDirtyCount = FALSE;
				window->uFrameCount = 0;
			}
			if ( window->OnPeriod( hdc, (UINT)drop ) ) {
				window->uPeriodNextTime += drop * (window->uPeriodTime - 1);
			}
			window->ReleaseDC(hdc);
		} else {
			window->bDirtyCount = TRUE;
			window->uPeriodNextTime += window->uPeriodTime;
		}
	}
}

void CALLBACK EXPORT GGameWindow::DispatchPeriod(HWND hwnd,UINT,UINT,DWORD ) {
	GGameWindow * window = (GGameWindow *)GetGWindow(hwnd);
	LONG now = timeGetTime();
	LONG exittime = now + window->uPeriodWMTimer ;//- window->uPeriodTime ;
	LONG drop, droptime;

	if ( now < exittime && !window->bFulldragging && (window->bCallOnPause || !window->GetPause() ) ) {
#if WINGL32
		DWORD osv = GetVersion();
		BOOL isWin32s = (osv & 0x80000000L) && ((osv & 0xff) < 4);
#endif
		HDC hdc = window->GetDC();
		if ( window->hpal && !__WinGLNoSelectPalette ) {
			SelectPalette(hdc,window->hpal,FALSE);
			RealizePalette(hdc);
		}

		now = timeGetTime();

		do {
#if WINGL16
			while ( now < window->uPeriodNextTime ) {
				now = timeGetTime();
			}
#else
			if ( now < window->uPeriodNextTime ) {
				if ( isWin32s ) {
					do {
						now = timeGetTime();
					} while ( now < window->uPeriodNextTime ) ;
				} else {
					GdiFlush();
					now = timeGetTime();
					if ( now < window->uPeriodNextTime )
						SleepEx( window->uPeriodNextTime - now, TRUE );
					now = timeGetTime();
				}
			}
#endif
			drop = (now - window->uPeriodNextTime) / window->uPeriodTime ;
			droptime = drop * (window->uPeriodTime - 1);
			++window->uPeriodCount;
			window->uPeriodNextTime += window->uPeriodTime;
			if ( window->bCallOnPause || !window->GetPause() ) {
				++window->uFrameCount;
				if ( now - window->uFrameTime >= 1000 ) {
					window->uFrameTime += 1000;
					if ( !window->bDirtyCount ) {
						window->uLastFrameCount = window->uFrameCount;
					}
					window->bDirtyCount = FALSE;
					window->uFrameCount = 0;
				}
				if ( window->OnPeriod( hdc, (UINT)drop ) ) {
					window->uPeriodNextTime += droptime;
				}
				if ( !window->idTimer )
					break;
			} else {
				window->bDirtyCount = TRUE;
			}
			now = timeGetTime();
		} while ( /*drop > 0 || */ now <= exittime ) ;
		window->ReleaseDC(hdc);
	} else {
		window->bDirtyCount = TRUE;
		window->uPeriodNextTime += window->uPeriodTime;
	}
}


#define WM_GMCIOPEN    (WM_USER)
#define WM_GMCICOMMAND (WM_USER+1)
#define WM_GMCISTATUS  (WM_USER+2)
//
// GMci implementation
//
#if WINGL32
DWORD WINAPI GMci::MciThreadFunc(DWORD lpmci) {
	GMci FAR * pmci = (GMci FAR *)lpmci;
	MSG msg;

	pmci->bThread = TRUE;

	while ( GetMessage(&msg, NULL, 0,0) ) {
		if ( msg.message == WM_GMCIOPEN ) {
			pmci->_Open( (LPCSTR)msg.wParam, (LPCSTR)msg.lParam ) ;
		} else if ( msg.message == WM_GMCICOMMAND ) {
			pmci->_SendCommand( (UINT)msg.wParam ) ;
		} else if ( msg.message == WM_GMCISTATUS ) {
			pmci->_Status( (UINT)msg.wParam ) ;
		} else {
#if MESSAGE_OUT == 2
			if ( msg.message != WM_TIMER )
				message_out(msg.message, msg.wParam, msg.lParam);
#endif
			DispatchMessage(&msg);
			//MessageBox(0, "are?",0, MB_ICONSTOP);
		}
	}
	pmci->bThread = FALSE;
	return 0;
}
#endif

GMci::GMci() : dwFlags(0),deviceId(0),bEnable(TRUE)
#if WINGL32
,bThread(FALSE),bDone(TRUE) 
#endif
{
	param.play.dwCallback = 0;
	param.play.dwFrom = 0;
	param.play.dwTo = 0;

	if ( midiOutGetNumDevs() == 0 ) {
		bEnable = FALSE;
		return;
	}

#if WINGL32
	HANDLE thread = CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)MciThreadFunc, (LPVOID)this, 0, &threadID);
#if 0
	char str[100];
	wsprintf(str, "GMci:: CreateThread -> thread(%x), threadID(%x)\n", thread, threadID );
	OutputDebugString(str);
#endif

	if ( thread ) {
		while ( !bThread ) {
			SleepEx(1,0);
		}
	}
#endif
}

GMci::~GMci() {
	if ( isOpen() )
		Close();
#if WINGL32
	if ( bThread ) {
		PostThreadMessage(threadID, WM_QUIT, 0,0 ) ;
		while ( bThread ) {
			SleepEx(1,0);
		}
	}
#endif
}

DWORD GMci::Open( LPCSTR szDevice, LPCSTR szModuleName ) {
	OFSTRUCT ofs;
	LPCSTR szmod = szModuleName;
	if ( isOpen() )
		Close();
	if ( szModuleName ) {
		if ( OpenFile( szModuleName, &ofs, OF_EXIST ) == HFILE_ERROR ) {
			lstrcpy( ofs.szPathName, szModuleName );
			szmod = ofs.szPathName;
		}
	}

#if WINGL32
	if ( bThread ) {
		while ( !bDone ) {
			Sleep(0);
		}
		bDone = FALSE;
		PostThreadMessage(threadID, WM_GMCIOPEN, (DWORD)szDevice, (DWORD)szmod);
		while ( !bDone ) {
			Sleep(0);
		}
		return dwResult;
	}
#endif
	return _Open(szDevice, szmod);
}

DWORD GMci::_Open( LPCSTR szDevice, LPCSTR szModuleName ) {
	MCI_OPEN_PARMS openParam;
	openParam.dwCallback = param.play.dwCallback;
	openParam.lpstrDeviceType = (LPSTR)szDevice;
	openParam.lpstrElementName = (LPSTR)szModuleName;
#if WINGL16
	openParam.wReserved0 = 0;
#endif
	DWORD a = mciSendCommand( 0, MCI_OPEN, dwFlags | MCI_WAIT | MCI_OPEN_TYPE | (szModuleName ? MCI_OPEN_ELEMENT:0), (DWORD)(LPVOID)&openParam);
	dwFlags = 0;
	if ( a == 0 ) {
		deviceId = (MCIDEVICEID)openParam.wDeviceID;
	}

#if WINGL32
#if 0
	char str[500];
	wsprintf(str, "deviceId(%d,%d), threadID(%x): uMsg=_Open(%s,%s), error = 256+%d\n", openParam.wDeviceID, deviceId, threadID, szDevice,szModuleName, a-256 ) ;
	OutputDebugString(str);
#endif

	dwResult = a;
	bDone = TRUE;
#endif
	return a;
}

DWORD GMci::SendCommand(UINT uMsg) {
#if WINGL32
	if ( bThread ) {
		while ( !bDone )
			Sleep(0);
		RunParam = param;
		dwRunFlags = dwFlags;
		dwFlags = 0;
		bDone = FALSE;
		PostThreadMessage(threadID, WM_GMCICOMMAND, (DWORD)uMsg, 0L);
		return 0;
	} else {
		RunParam = param;
		dwRunFlags = dwFlags;
		dwFlags = 0;
	}
#endif
	return _SendCommand(uMsg);
}

DWORD GMci::_SendCommand(UINT uMsg) {
	DWORD a = 0;
	if ( isOpen() ) {
#if WINGL16
		do {
			a = mciSendCommand(deviceId, uMsg, dwFlags, (DWORD)(LPVOID)&param );
		} while ( a == MCIERR_SEQ_PORT_INUSE );
		dwFlags = 0;
#else
		do {
			a = mciSendCommand(deviceId, uMsg, dwRunFlags, (DWORD)(LPVOID)&RunParam );
		} while ( a == MCIERR_SEQ_PORT_INUSE );

#if 0
		char str[80];
		wsprintf(str, "deviceId(%d), threadID(%x): uMsg=0x%04x, error = 256+%d\n", deviceId, threadID, uMsg, a - 256 ) ;
		OutputDebugString(str);
#endif
#endif

		if ( uMsg == MCI_CLOSE ) {
			deviceId = 0;
		}
	}
#if WINGL32
	bDone = TRUE;
#endif
	return a;
}

DWORD GMci::Status( DWORD dwFlags, DWORD dwItem, DWORD dwTrack ) {
	dwFlags |= MCI_WAIT;
	StatusParam.dwItem = dwItem;
	StatusParam.dwTrack = dwTrack;

#if WINGL32
	if ( bThread ) {
		while ( !bDone )
			Sleep(0);
		bDone = FALSE;
		PostThreadMessage(threadID, WM_GMCISTATUS, (DWORD)dwFlags, 0L);
		while ( !bDone )
			Sleep(0);
		return dwResult;
	}
#endif
	return _Status(dwFlags);
}

DWORD GMci::_Status( DWORD dwFlags ) {
#if !WINGL32
	DWORD dwResult;
#endif
	dwResult = 0;

	if ( isOpen() ) {
		DWORD a;
		do {
			a = mciSendCommand(deviceId, MCI_STATUS, dwFlags, (DWORD)(LPVOID)&StatusParam );
		} while ( a == MCIERR_SEQ_PORT_INUSE );
		if ( a == 0 ) {
			dwResult = StatusParam.dwReturn;
		}
	}
#if WINGL32
	bDone = TRUE;
#endif
	return dwResult;
}

DWORD GMci::Close() {
	SetWait();
	Stop();
	SetWait();
	return SendCommand(MCI_CLOSE);
}

//
// GWave implementation
//
int GWave::UseCount = 0;

GWave::GWave() : bLoaded(FALSE),bEnable(TRUE) {}

GWave::~GWave() {
	Close();
}

BOOL GWave::Open(HINSTANCE hinst, HWND hwnd, LPCSTR resname, BOOL is_file, int max_simul) {
	if ( !bLoaded ) {
		hwav = 0;
		if ( UseCount == 0 ) {
			if ( WinGLWaveInit(hinst, hwnd) == WAVEMODE_NOWAVE ) {
				bEnable = FALSE;
			}
		} else {
			for ( hwav = 0 ; hwav < WINGLWAVE_MAX ; ++hwav ) {
				if ( !WinGLWaveExist(hwav) )
					break;
			}
		}
		if ( bEnable && WinGLWaveLoadEx(resname, is_file, UseCount, max_simul ) ) {
			++UseCount;
			bLoaded = TRUE ;
		}
		return bLoaded;
	}
	/* ɂȂɂǂݍ܂Ă̂ȂA܂ȂƓǂ߂Ȃ */
	return FALSE;
}

void GWave::Close() {
	if ( bLoaded ) {
		WinGLWaveFree(hwav);
		bLoaded = FALSE;
		if ( --UseCount == 0 ) {
			WinGLWaveEnd();
		}
	}
}

int GWave::Play(DWORD flags) {
	if ( bEnable && bLoaded ) {
		return WinGLWavePlayEx(hwav, flags);
	}
	return -1;
}

void GWave::SetFrequency(int index, DWORD Hz) {
	if ( bEnable && bLoaded ) {
		WinGLWaveSetFrequency(hwav,index,Hz);
	}
}

//
// GApp Implementation
//
BOOL GApp::AddIdle(IDLEPROC proc, LPVOID param) {
	if ( numIdle < MaxIdle ) {
		Idles[numIdle].pOnIdle = proc;
		Idles[numIdle].pParamIdle = param;
		++numIdle;
		return TRUE;
	}
	return FALSE;
}

BOOL GApp::RemoveIdle(IDLEPROC proc, LPVOID param) {
	for ( int i = 0 ; i < numIdle ; ++i ) {
		if ( Idles[i].pOnIdle == proc && Idles[i].pParamIdle == param) {
			if ( i <= currentIdle )
				--currentIdle;
			--numIdle;
			for ( ; i < numIdle ; ++i ) {
				Idles[i] = Idles[i+1];
			}
			return TRUE;
		}
	}
	return FALSE;
}

// numIdreidre routine̐
int GApp::Run(HWND hwnd, HACCEL hAccel, int& currentIdle, int& numIdle, IDLES * Idles ) {
	MSG msg;

	for (;;) {
		if ( PeekMessage( &msg, NULL,0,0, TRUE ) ) {
			if ( msg.message == WM_ACTIVATEAPP && msg.hwnd == hwnd && msg.wParam == FALSE ) {
				GWindow * window = GetGWindow(hwnd);
				window->OnActivate(msg.wParam);
			}
			if ( !hAccel || !TranslateAccelerator(hwnd, hAccel, &msg) ) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
				if ( msg.message == WM_QUIT )
					break;
			}
		} else {
			if ( !numIdle ) {
				WaitMessage();
			} else {
				if ( currentIdle >= numIdle )
					currentIdle = 0;
				int i = currentIdle;
				Idles[i].pOnIdle( Idles[i].pParamIdle );
				++currentIdle;
			}
		}
	}
	return msg.wParam;
}

int GApp::MessageLoop() {
	exitCode = Run(MainWindow->getHWND(), hAccel, currentIdle, numIdle, Idles);
	return exitCode ;
}
