/* WinGL L1
// version 0.11e
// Copyright (C)1995-1997 A.Koizuka,alty / Bio_100%  All Rights Reserved.
// $Header: /WinGL/WINGL.H 29    97/02/01 7:00 Koizuka $
*/

#if !defined(_INC_WINGL)
# define _INC_WINGL

#if !defined(_INC_WINDOWS) && !defined(__WINDOWS_H)
# include <windows.h>    /* Include windows.h if not already included */
#endif

/* Resource Type */
#define RT_WINGLROP             "WINGLROP"

#ifdef __cplusplus
class WINGL;
#else
typedef struct WINGL WINGL;
#endif
#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(__NT__)
# define WINGLAPI __stdcall
# if defined(_MSC_VER) && _MSC_VER >= 900
#  pragma warning( disable : 4514 )
#  define EXPORT
# elif defined(__TURBOC__)
#  define _export
# endif
typedef WINGL * LPWINGL;
typedef const WINGL * LPCWINGL;
# define HUGE

# define WINGL16 0
# define WINGL32 1
# ifndef _WIN32
#  define _WIN32 1
# endif
# if !defined(__TURBOC__) || __TURBOC__ >= 0x460
#  include <objbase.h>
# else
#  define LPCRECT LPRECT
# endif
#else
# define WINGLAPI _far _pascal
# define EXPORT _export
# define HUGE __huge
typedef WINGL FAR * LPWINGL;
typedef const WINGL FAR * LPCWINGL;

# define WINGL16 1
# define WINGL32 0
# if 0 /* !defined(__TURBOC__) || __TURBOC__ > 0x460 */
# include <compobj.h>
# endif
#endif

typedef unsigned char FAR * WINGLROP;
typedef unsigned char FAR * WINGLTBL;

#ifdef __cplusplus
extern "C" {
#endif

#define ResourceNotFound -1
#define TooManyPattern   -2
#define OutOfMemory      -3
#define FileOpenError    -4
#define RopNull          -5
#define InvalidHandle    -6
#define TooNewDAR        -7
#define InvalidWingl     -8

#ifdef DEFINE_GUID
/* \GUID
51e54a60-3171-11cf-a851-004026021284
51e54a61-3171-11cf-a851-004026021284
51e54a62-3171-11cf-a851-004026021284
51e54a63-3171-11cf-a851-004026021284
51e54a64-3171-11cf-a851-004026021284
*/

DEFINE_GUID( IID_IWinGL,         0x533577a0,0x3171,0x11cf,0xa8,0x51,0x00,0x40,0x26,0x02,0x12,0x84 );
DEFINE_GUID( IID_IWinGLSurface,  0x533577a1,0x3171,0x11cf,0xa8,0x51,0x00,0x40,0x26,0x02,0x12,0x84 );
DEFINE_GUID( IID_IWinGLInput,    0x533577a2,0x3171,0x11cf,0xa8,0x51,0x00,0x40,0x26,0x02,0x12,0x84 );
DEFINE_GUID( IID_IWinGLMusic,    0x533577a3,0x3171,0x11cf,0xa8,0x51,0x00,0x40,0x26,0x02,0x12,0x84 );
DEFINE_GUID( IID_IWinGLSound,    0x533577a4,0x3171,0x11cf,0xa8,0x51,0x00,0x40,0x26,0x02,0x12,0x84 );
#endif


		/* F萔 */
#define PAL_BLACK		0
#define PAL_BROWN		1
#define PAL_DARKGREEN	2
#define PAL_DARKYELLOW	3
#define PAL_DARKBLUE	4
#define PAL_DARKMAGENTA	5
#define PAL_DARKCYAN	6
#define PAL_LIGHTGRAY	7
#define PAL_DARKGRAY	248
#define PAL_RED			249
#define PAL_GREEN		250
#define PAL_YELLOW		251
#define PAL_BLUE		252
#define PAL_MAGENTA		253
#define PAL_CYAN		254
#define PAL_WHITE		255


/* WinGL Internal method */


typedef struct WINGLPREP FAR * LPWINGLPREP;
typedef struct WINGLPREP WINGLPREP;
struct WINGLPREP {		/* `揀\(WinGLPrepareDrawŐݒ肳) */
	/*---- ȉ̓p[^ ----*/
	int x;
	int y;
	unsigned patnum;
	int zoomx;
	int zoomy;
	WINGLROP rop;
	/*---- ȏオp[^ ----*/
	/*---- ȉ WinGLPrepareDrawɂ菑܂ ----*/

	long Width;					/* `悷ׂ(Ppixel) */
	long Height;					/* `悷ׂ(Ppixel) */

	  /*---- ȉ͎sɂj󂳂 ----*/
#if WINGL16
	unsigned char huge *pSource;	/* ړĨp^[̕`Jny̍[addr */
	WORD DestSelector;				/* `ΏDIB̃ZN^ */
#else
	unsigned char *pSource;			/* ړĨp^[̕`Jny̍[addr */
#endif
	DWORD DestOffset;				/* `ΏDIB̕`JnItZbg */
	  /*---- ȏ͎sɂj󂳂 ----*/
	long destPitch;					/* `ΏDIB1linẽAhX */
	long srcPitch;					/* p^[1linẽAhX */
	long XBlank ;					/* p^[̍XLbv(pixel) */
	long XRBlank ;					/* p^[̉EXLbv(pixel) */
	int BottomCut ;					/* Nbvɂč(pixel) */

	/*---- ȏオ WinGLPrepareDrawɂ菑܂ ----*/

	long _len2;
	long _wx;

	/*---- ȉ̓eNX`gp̃p[^ ----*/
	DWORD mesh;						/* bV}XNp^[ */
#if WINGL16
	WORD TextureSelector;
	DWORD TextureOffset;
#else
	unsigned char * pTexture;
#endif
	long texturePitch;
} ;
typedef void (WINGLAPI *WINGLPAINTFUNC)(LPWINGLPREP);
extern void WINGLAPI WinGLDrawDAR(LPWINGLPREP);				/* W */
extern void WINGLAPI WinGLDrawDAR_Rx(LPWINGLPREP);			/* E] */
extern void WINGLAPI WinGLDrawDAR_Zx(LPWINGLPREP);			/* gk */
extern void WINGLAPI WinGLDrawDAR_Rx_Zx(LPWINGLPREP);		/* E]gk */
extern void WINGLAPI WinGLDrawDAR_Rop(LPWINGLPREP);			/* ROP */
extern void WINGLAPI WinGLDrawDAR_Rop_Rx(LPWINGLPREP);		/* ROPE] */
extern void WINGLAPI WinGLDrawDAR_Rop_Zx(LPWINGLPREP);		/* ROPgk */
extern void WINGLAPI WinGLDrawDAR_Rop_Rx_Zx(LPWINGLPREP);	/* ROPE]gk */
extern void WINGLAPI WinGLDrawDAR_Tbl(LPWINGLPREP);			/* TBL */
extern void WINGLAPI WinGLDrawDAR_Tbl_Rx(LPWINGLPREP);		/* TBLE] */
extern void WINGLAPI WinGLDrawDAR_Tbl_Zx(LPWINGLPREP);		/* TBLgk */
extern void WINGLAPI WinGLDrawDAR_Tbl_Rx_Zx(LPWINGLPREP);	/* TBLE]gk */
extern void WINGLAPI WinGLDrawDAR_Mesh(LPWINGLPREP);		/* Mesh */
extern void WINGLAPI WinGLDrawDAR_Mesh_Rx(LPWINGLPREP);		/* MeshE] */
extern void WINGLAPI WinGLDrawDAR_Mesh_Zx(LPWINGLPREP);		/* Meshgk */
extern void WINGLAPI WinGLDrawDAR_Mesh_Rx_Zx(LPWINGLPREP);	/* MeshE]gk */
BOOL PASCAL WinGLPrepareDraw( LPWINGL wingl, LPWINGLPREP prep ) ;

#if WINGL32

extern void WINGLAPI RopFillDIBBits( unsigned char * pDest,
	DWORD Width, DWORD Height, long DestWidth,
	const unsigned char * RopTable, unsigned char FillColor ) ;

#else   /* if WINGL32 else */

void WINGLAPI memset48( WORD DestSelector, DWORD DestOffset, int fillbyte, long length );

void WINGLAPI RopFillDIBBits( WORD DestSelector, DWORD DestOffset,
	DWORD Width, DWORD Height, long DestWidth,
	WORD RopTableSeg, unsigned char FillColor ) ;

#endif

#define WDS_NORMAL	(0)
#define WDS_FLIPX	(1 << 0)
#define WDS_ZOOMX	(1 << 1)
#define WDS_ROP		(1 << 2)	/* ROP,TBL,MESH,ROP0͔r֌W */
#define WDS_TBL		(2 << 2)
#define WDS_MESH	(3 << 2)
#define WDS_ROP0	(4 << 2)
#define WDS_DOTTEDZOOMX ((1 << 5)|WDS_ZOOMX)

#define WDS_FLIPY	(1 << 7)

#define WDS_HIGHSHIFT	8
#define WDS_ZOOMY	(1 << WDS_HIGHSHIFT)
#define WDS_WAVEX	(1 << (WDS_HIGHSHIFT+1))
#define WDS_VIBRA	(2 << (WDS_HIGHSHIFT+1))
#define WDS_DOTTEDZOOMY ((3 << (WDS_HIGHSHIFT+1))|WDS_ZOOMY)


#define WDS_HIGHMASK	(WDS_ZOOMY|WDS_WAVEX|WDS_VIBRA|WDS_DOTTEDZOOMY)
#define WDS_LOWMASK		(WDS_FLIPX|WDS_ZOOMX|WDS_ROP|WDS_TBL|WDS_MESH|WDS_ROP0|WDS_DOTTEDZOOMX)

typedef struct WGLDRAWSTRUCT WGLDRAWSTRUCT;
typedef struct WGLDRAWSTRUCT FAR * LPWGLDRAWSTRUCT;
typedef const struct WGLDRAWSTRUCT FAR * LPCWGLDRAWSTRUCT;
struct WGLDRAWSTRUCT {
	DWORD flags;	/* WDS_... */
	int patnum;

	int x,y;

	int zoomx;			/* all */
	int zoomy;			/* ZOOMY */

	int len;			/*       WAVE VIBRA */
	int amp;			/*       WAVE */
	int ph;				/*       WAVE VIBRA */

	WINGLROP rop;		/*                  ROP */
	DWORD mesh;			/*                      MESH */
};

/* *Lock2 Őݒ肳T[tFCX\ */
typedef struct WGLLOCK2 WGLLOCK2;
typedef struct WGLLOCK2 FAR * LPWGLLOCK2;
typedef const struct WGLLOCK2 FAR * LPCWGLLOCK2;
struct WGLLOCK2 {
	DWORD dWidth;     /* C[Wobt@̉ */
	DWORD dHeight;    /* C[Wobt@̍ */
	LPBYTE lpImage;   /* C[Wobt@̐擪AhX */
	long lTopOffset;  /* lpImage(0,0)ւ̑΃ItZbgAhX */
	long lPitch;      /* 1lineɈړ邽߂̑΃AhX */
	RECT rectClip;    /* Nbvg */

#ifdef __cplusplus
	void Draw( LPCWGLDRAWSTRUCT wds ) const;
#endif
};

void WINGLAPI PatDraw2( LPCWGLLOCK2 dest, LPCWGLDRAWSTRUCT ds );
#if WINGL32
BOOL WINGLAPI PatDrawBoundRect( LPCRECT rectClip, LPCWGLDRAWSTRUCT ds, LPRECT rectBound ) ;
#else
BOOL WINGLAPI PatDrawBoundRect( LPRECT rectClip, LPCWGLDRAWSTRUCT ds, LPRECT rectBound ) ;
#endif
#define PatDrawBound(wingl,ds,rectBound) PatDrawBoundRect(&(wingl)->rectClip,ds,rectBound)
#define PatDrawBound2(lock,ds,rectBound) PatDrawBoundRect(&(lock)->rectClip,ds,rectBound)
void WINGLAPI PatDraw( LPWINGL wingl, LPCWGLDRAWSTRUCT ds );
void WINGLAPI PatDrawDIB( LPBITMAPINFOHEADER dib, LPVOID lpSurface, LPCWGLDRAWSTRUCT ds );
void WINGLAPI PatDrawPat( int patnum, LPCWGLDRAWSTRUCT ds );

#ifdef __cplusplus
inline void WGLLOCK2::Draw( LPCWGLDRAWSTRUCT wds ) const {
	PatDraw2(this, wds);
}
#endif

typedef struct WGLBACKUPSTRUCT WGLBACKUPSTRUCT;
typedef WGLBACKUPSTRUCT FAR * LPWGLBACKUPSTRUCT;
struct WGLBACKUPSTRUCT {
	RECT rect;
	unsigned pitch;
#if WINGL16
	WORD segBuffer;
	DWORD offBuffer;
#else
	LPBYTE pBuffer;
#endif
};

BOOL WINGLAPI WinGLBackup( LPWINGL wingl, LPRECT rect, LPWGLBACKUPSTRUCT bs );
BOOL WINGLAPI WinGLRestore( LPWINGL wingl, LPWGLBACKUPSTRUCT bs );
BOOL WINGLAPI WinGLRestoreEx( LPWINGL wingl, LPWGLBACKUPSTRUCT bs, WORD flags);
#define WGLRESTOREEX_FREE    1
#define WGLRESTOREEX_RESTORE 2

enum WPMEMTYPE {
  WPMT_RDIB,		/* resource DIB */
  WPMT_FDIB,		/* file DIB */
  WPMT_RDAR,		/* resource DAR */
  WPMT_FDAR,		/* file DAR */
  WPMT_ALLOC,		/* local */
} ;

/* Pattern Functions */
typedef struct WINGLPAT WINGLPAT;
struct WINGLPAT {
	LPBITMAPINFOHEADER pBitmap;		/* p^[ɑΉDIB, NULLȂ疢gpp^[ */
				/* PatEntryDARœo^ꂽꍇADIBC[W͋ɂȂ邪A*/
				/* pbge[ui[ꂽpBitmapwB*/
	LPVOID pDataTop;				/* p^[̃C[W擪(ŉs[) */
	LPVOID pDibSurface;				/* DIB̃C[W擪(ŉs[) */
	WORD hGroup;					/* O[vnh */
	WORD wFlag;						/* ([U[`) */
	short dx, dy;					/* p^[\vf1̑傫 */
	short sy, ry;					/* Lȏ[Jn_ƁAp^[Ŝ̍ */
	short ox, oy;					/* p^[̌_ */
	int widthBytes ;				/* p^[1linẽAhX(1line֐i(ł͂Ȃ!)) */
	int tcolor;						/* ƂĒułF(-1Ȃ疳) */
#if WINGL32
	LPVOID pDDSurface;
#endif
	LPCSTR name;
} ;

#define HGPAT_ALLOC	0
typedef struct WINGLPATGROUP WINGLPATGROUP;
struct WINGLPATGROUP {
	int refCount;
	enum WPMEMTYPE memoryType;
	HGLOBAL hglbDar;			/* WPMT_RDAR only */
	LPVOID lpDar;				/* WPMT_RDAR and WPMT_FDAR only */
};

extern WINGLPAT WinGLPat[];                 /* p^[ */
extern const unsigned WinGLMaxPat;          /* őp^[ */
extern unsigned WinGLPatNum;  /* o^ꂽp^[ */
#define MAXPAT   WinGLMaxPat

extern BOOL __WinGLNoSelectPalette;

#define MAXPATGROUP 32
extern WINGLPATGROUP WinGLPatGroup[MAXPATGROUP];
extern int WinGLPatGroupNum;

#define PatExist(num)         ((unsigned)(num) < WinGLPatNum && WinGLPat[num].pBitmap != 0)
#define PatMemType(num)       WinGLPatGroup[WinGLPat[num].hGroup].memoryType
#define PatTColor(num)        WinGLPat[num].tcolor
#define PatSizeX(num)         WinGLPat[num].dx
#define PatSizeY(num)         WinGLPat[num].dy
#define PatSizeRY(num)        WinGLPat[num].ry
#define PatWidthBytes(num)    WinGLPat[num].widthBytes
#define PatPtrYB(num,yb)      ((LPSTR)WinGLPat[num].pDataTop + PatWidthBytes(num)*(yb))
#define PatPtrY(num,y)        PatPtrYB(num,PatSizeRY(num)-(y)-1)
#define PatDibWidthBytes(num) DibWidthBytes(WinGLPat[num].pBitmap)
#define PatDibPtrYB(num,yb)   ((LPSTR)WinGLPat[num].pDibSurface + PatDibWidthBytes(num)*(yb))
#define PatDibPtrY(num,y)     PatDibPtrYB(num,PatSizeRY(num)-(y)-1)
#define PatColors(num)        ((LPRGBQUAD)((LPBYTE)(WinGLPat[num].pBitmap) + (unsigned)WinGLPat[num].pBitmap->biSize))
#define PatIsDAR(num)         (WinGLPat[num].pDibSurface == 0)
#define PatGetFlag(patnum)    WinGLPat[patnum].wFlag
#define PatDivY(num,h)        (WinGLPat[num].dy = (short)(h))
#define PatSel(num,i)         (WinGLPat[num].sy = (short)(WinGLPat[num].dy * (i)))
#define PatOrigin(num,x,y)    (WinGLPat[num].ox = (x), WinGLPat[num].oy = (y))
#define PatGetName(num)       WinGLPat[num].name
int WINGLAPI PatFindByName( int first_pat, int last_pat, LPCSTR name, int index ) ;

int WINGLAPI PatEntryName( LPCSTR bmpname, int tcolor ) ;
int WINGLAPI PatSliceEntryName( LPCSTR bmpname, unsigned xsize, unsigned ysize, int tcolor ) ;
int WINGLAPI PatEntryDIB( int top_pat, int matxpat, LPCSTR bmpname, BOOL is_resource, unsigned xsize, unsigned ysize, int tcolor, LPRGBQUAD trgb ) ;
int WINGLAPI PatEntryDAR( int top_pat, int maxpat, HINSTANCE hInstApp, LPCSTR resname, LPCSTR restype, HGLOBAL FAR * hglbDAR ) ;
#define PatFreeDAR(hglbDAR)
int WINGLAPI PatEntryDARFile( int top_pat, int maxpat, LPCSTR filename );
int WINGLAPI PatEntryDAR_Memory( int top_pat, int maxpat, enum WPMEMTYPE mt, unsigned char HUGE * resptr );
void WINGLAPI PatFree( int patnum ) ;
void WINGLAPI PatRelease( int patnum ) ;
#define PatEntryID(id,tc) PatEntryName(MAKEINTRESOURCE(id),(tc))
#define PatSliceEntryID(id,xs,ys,tc) PatSliceEntryName(MAKEINTRESOURCE(id),xs,ys,tc)

int WINGLAPI PatAlloc( int patnum, unsigned width, unsigned height, int fillcolor, int tcolor ) ;
int WINGLAPI PatAlloc2( LPWGLLOCK2 lock, int patnum, unsigned width, unsigned height, LPRGBQUAD init_palette, int fillcolor, int tcolor );
int WINGLAPI PatAllocDraw( int to_pat, LPCWGLDRAWSTRUCT wds_from, BOOL bWholePat );
#define PatSetFlag(patnum,dwNew) (WinGLPat[patnum].wFlag = (WORD)dwNew)
BOOL WINGLAPI PatGenerateDIB(int patnum ) ;
BOOL WINGLAPI PatDibFree( int num ) ;
#if WINGL32
BOOL WINGLAPI PatGenerateDD( int patnum );
void WINGLAPI PatReleaseDD( int patnum );
#endif
HPALETTE WINGLAPI PatCreatePalette( int patnum ) ;
BOOL WINGLAPI DibLock2( LPWGLLOCK2 lock, LPBITMAPINFOHEADER dib, LPVOID lpSurface );
#define DibUnlock2(lock,dib,pSurface) /* ignore */
BOOL WINGLAPI PatLock2( LPWGLLOCK2 lock, int patnum );
BOOL WINGLAPI PatUnlock2( LPWGLLOCK2 lock, int patnum );

void WINGLAPI TextDraw2( LPWGLLOCK2 lock, HDC hdc, int x, int y, LPCSTR text, int color );

#if WINGL32
#define Lock2PtrXY(lock,x,y) ((lock)->lpImage + (lock)->lTopOffset + (x) + (y) * (lock)->lPitch)
#else
#define Lock2Seg(lock)          ((WORD)((DWORD)(lock)->lpImage) >> 16)
#define Lock2OffsetXY(lock,x,y) ((DWORD)(lock)->lTopOffset + (x) + (y) * (lock)->lPitch)
#define Lock2PtrXY(lock,x,y) ((BYTE HUGE *)(lock)->lpImage + Lock2OffsetXY(lock,x,y))
#endif

/* internal routine */
BOOL WINGLAPI PatAllocateDIB(LPRGBQUAD init_palette, int patnum, int fillcolor, int height, BOOL isDAR);

#define PATDC_FUCHIDORI 1
typedef struct WINGLPATDC WINGLPATDC;
typedef struct WINGLPATDC FAR * LPWINGLPATDC;
struct WINGLPATDC {
	int patnum;
	DWORD dwflag;
	HDC hdc;
	HBITMAP bitmap;
	HBITMAP lastBitmap;
	HPALETTE palette;
	int argcolor;
};

BOOL WINGLAPI PatCreateDC( LPWINGLPATDC lpdc ) ;
void WINGLAPI PatRebuildDAR(int patnum);
int WINGLAPI PatSelectObject(LPWINGLPATDC lpdc, int patnum);
void WINGLAPI PatDeleteDC( LPWINGLPATDC lpdc ) ;

extern HINSTANCE WinGLInst;
#define WinGLSetInst(i)		(WinGLInst = i)

/* WinGL functions */
enum WINGLBLTTYPE {
	WIBT_DIBITS,
	WIBT_WING,
	WIBT_SECTION,
	WIBT_DIRECTDRAW,
};
struct WINGLINFO {
	DWORD wiSize;		/* ̍\̂̑傫(oCg) */
	WORD wiVersion;
	WORD wiCount;
	WORD wiBltType;
};
WORD WINGLAPI WinGLGetInfo( struct WINGLINFO FAR * wi );

#define WGL_WINDOW 0
#define WGL_FULLSCREEN 1
#define WGL_CLIP             2
#define WGL_SYSTEMMEMORY 4
#define WGL_VIDEOMEMORY    8
#define WGL_FLIP                   16
#define WGL_STRICTRES  32
#define WGL_TEST 0x8000
#define WGL_FULLSCREEN_CLIP (WGL_FULLSCREEN+WGL_CLIP)
#define WGL_FLIPSCREEN (WGL_FULLSCREEN+WGL_FLIP)
#define WGL_FULLSCREEN_TEST (WGL_FULLSCREEN+WGL_TEST)
#define WGL_FLIPSCREEN_TEST (WGL_FLIPSCREEN+WGL_TEST)
typedef unsigned short WINGLSCREENTYPE;

void WINGLAPI WinGLInit( LPWINGL wingl ) ;
void WINGLAPI WinGLInitEx( LPWINGL wingl, HWND hwndDDraw ) ;
void WINGLAPI WinGLSize( LPWINGL wingl, int dx, int dy, int patnum, HPALETTE FAR * phpalApp ) ;
BOOL WINGLAPI WinGLScreenMode( LPWINGL wingl, WINGLSCREENTYPE mode );
void WINGLAPI WinGLEnd( LPWINGL wingl) ;
BOOL WINGLAPI WinGLLock2( LPWGLLOCK2 lock, LPWINGL wingl );
BOOL WINGLAPI WinGLAssure(BOOL active);
#define WinGLUnlock2(lock,wingl)  WinGLUnlock(wingl)
extern BOOL (WINGLAPI *WinGLLock)( LPWINGL wingl );
extern void (WINGLAPI *WinGLUnlock)( LPWINGL wingl );
extern HDC (WINGLAPI *WinGLGetDC)( LPWINGL wingl );
extern void (WINGLAPI *WinGLReleaseDC)( LPWINGL wingl );
void WINGLAPI WinGLPaint( LPCWINGL wingl, HDC hdc, int hx, int hy ) ;
void WINGLAPI WinGLBitBlt( HDC dest, int destx, int desty, int width, int height,
				LPCWINGL wingl, int srcx, int srcy ) ;
void WINGLAPI WinGLBlt( LPCWINGL winglDest, int destx, int desty, int width, int height, LPCWINGL wingl, int srcx, int srcy );
void WINGLAPI WinGLClear( LPWINGL wingl, int fillcolor) ;
BOOL WINGLAPI WinGLFillRect( LPWINGL wingl, const RECT FAR * rect, int fillcolor) ;
BOOL WINGLAPI WinGLFillRect2( LPWGLLOCK2 lock, const RECT FAR * rectSource, int color );
HPALETTE WINGLAPI WinGLCreatePalette( LPWINGL wingl ) ;
void WINGLAPI WinGLError(int errorcode, LPCSTR mes) ;
LPVOID WINGLAPI GetResource(LPCSTR szResType, LPCSTR szResName) ;
#ifdef __DDRAW_INCLUDED__
void WINGLAPI WinGLGetDD( LPDIRECTDRAW * lplpDD, LPDIRECTDRAWSURFACE * lplpDDScreen );
#endif
LPWINGL WINGLAPI WinGLGetFullScreen(void);
BOOL WINGLAPI WinGLCopyToClipboardDIB( LPWINGL wingl );

/* ROP functions */
void WINGLAPI RopInit( WINGLROP rop ) ;
void WINGLAPI RopFromTbl( WINGLROP rop, const WINGLTBL tbl, unsigned char from, unsigned char to ) ;
WINGLROP WINGLAPI CreateRop( void ) ;
void WINGLAPI DeleteRop( WINGLROP rop ) ;
void WINGLAPI TransparentRop( WINGLROP rop, unsigned char TransparentColor ) ;
void WINGLAPI VisibleRop( WINGLROP rop, unsigned char VisibleColor ) ;
void WINGLAPI ForwardBackgroundRop( WINGLROP rop, unsigned char forwardColor ) ;
void WINGLAPI TranslucentRop( const RGBQUAD FAR * pal, WINGLROP rop,
					unsigned char tcolor1, unsigned char tcolor2, int percent) ;
void WINGLAPI ChangeColorRop( WINGLROP rop, unsigned char first, unsigned char last,
					unsigned char to_color ) ;
void WINGLAPI GrayScaleRop( const RGBQUAD FAR * pal, WINGLROP rop, int tcolor1, int tcolor2,
				unsigned char black, unsigned char white ) ;
void WINGLAPI WriteRopToFile( WINGLROP rop, LPCSTR filename ) ;
void WINGLAPI ReadRopFromResource( WINGLROP rop, HINSTANCE hInst, LPCSTR restype, LPCSTR resname ) ;

/* TBL functions */
void WINGLAPI TblInit( WINGLTBL tbl );
WINGLTBL WINGLAPI CreateTbl(void);
void WINGLAPI DeleteTbl( WINGLTBL tbl );
void WINGLAPI TblColorMatch( WINGLTBL tbl, const RGBQUAD FAR * dest_pal, const RGBQUAD FAR * src_pal ) ;
void WINGLAPI TblBlendColor( WINGLTBL tbl, const RGBQUAD FAR * dest_pal, const RGBQUAD FAR * src_pal, RGBQUAD blend_color, int percentage );
void WINGLAPI TblGrayScale( const RGBQUAD FAR * pal, WINGLTBL tbl, int tcolor1, int tcolor2, unsigned char black, unsigned char white ) ;

/* drawing method */
void WINGLAPI WinGLPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, WINGLPAINTFUNC paint, WINGLROP rop ) ;
void WINGLAPI WinGLWavePut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len,
			signed char amp, int ph, WINGLPAINTFUNC paint, WINGLROP rop ) ;
void WINGLAPI WinGLZoomVPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int yzoom,
			WINGLPAINTFUNC paint, WINGLROP rop ) ;
void WINGLAPI WinGLVibraPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len,
			signed int ph, WINGLPAINTFUNC paint, WINGLROP rop ) ;
void WINGLAPI MaskPut(LPWINGL wingl,int x,int y,int patnum, int cx, int cy, int cpatnum );
void WINGLAPI MaskPutDIB(LPWINGL wingl,int x,int y,int patnum, int cx, int cy,
			BITMAPINFOHEADER FAR * bmi, LPVOID pBits ) ;

#ifdef __cplusplus
inline void PatPut(LPWINGL wingl,int x,int y,int patnum) {
	WinGLPut(wingl,x,y,patnum,256,WinGLDrawDAR,0);
}
inline void PatZoomHPut( LPWINGL wingl, int x, int y, int patnum, int xzoom ) {
	WinGLPut(wingl,x,y,patnum,xzoom,WinGLDrawDAR_Zx,0);
}
inline void RopPut(LPWINGL wingl,int x,int y,int patnum,WINGLROP rop) {
	WinGLPut(wingl,x,y,patnum,256,WinGLDrawDAR_Rop,rop);
}
inline void RopZoomHPut( LPWINGL wingl, int x, int y, int patnum, int xzoom,WINGLROP rop ) {
	WinGLPut(wingl,x,y,patnum,xzoom,WinGLDrawDAR_Rop_Zx,rop);
}

inline void PatWavePut( LPWINGL wingl, int x, int y, int patnum, int len, char amp, int ph ) {
	WinGLWavePut(wingl,x,y,patnum,256,len,amp,ph,WinGLDrawDAR,0);
}
inline void PatZoomHWavePut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len, char amp, int ph ) {
	WinGLWavePut(wingl,x,y,patnum,xzoom,len,amp,ph,WinGLDrawDAR_Zx,0);
}
inline void RopWavePut( LPWINGL wingl, int x, int y, int patnum, int len, char amp, int ph, WINGLROP rop ) {
	WinGLWavePut(wingl,x,y,patnum,256,len,amp,ph,WinGLDrawDAR_Rop,rop);
}
inline void RopZoomHWavePut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len, char amp, int ph, WINGLROP rop ) {
	WinGLWavePut(wingl,x,y,patnum,xzoom,len,amp,ph,WinGLDrawDAR_Rop_Zx,rop);
}

inline void PatVibraPut( LPWINGL wingl, int x, int y, int patnum, int len, int ph ) {
	WinGLVibraPut(wingl,x,y,patnum,256,len,ph,WinGLDrawDAR,0);
}
inline void PatZoomHVibraPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len, int ph ) {
	WinGLVibraPut(wingl,x,y,patnum,xzoom,len,ph,WinGLDrawDAR_Zx,0);
}
inline void RopVibraPut( LPWINGL wingl, int x, int y, int patnum, int len, int ph,WINGLROP rop ) {
	WinGLVibraPut(wingl,x,y,patnum,256,len,ph,WinGLDrawDAR_Rop,rop);
}
inline void RopZoomHVibraPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int len, int ph, WINGLROP rop ) {
	WinGLVibraPut(wingl,x,y,patnum,xzoom,len,ph,WinGLDrawDAR_Rop_Zx,rop);
}

inline void PatZoomVPut( LPWINGL wingl, int x, int y, int patnum, int zoom ) {
	WinGLZoomVPut(wingl,x,y,patnum,256,zoom,WinGLDrawDAR,0);
}
inline void PatZoomPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int yzoom ) {
	WinGLZoomVPut(wingl,x,y,patnum,xzoom,yzoom,WinGLDrawDAR_Zx,0);
}
inline void RopZoomVPut( LPWINGL wingl, int x, int y, int patnum, int zoom,WINGLROP rop ) {
	WinGLZoomVPut(wingl,x,y,patnum,256,zoom,WinGLDrawDAR_Rop,rop);
}
inline void RopZoomPut( LPWINGL wingl, int x, int y, int patnum, int xzoom, int yzoom, WINGLROP rop) {
	WinGLZoomVPut(wingl,x,y,patnum,xzoom,yzoom,WinGLDrawDAR_Rop_Zx,rop);
}

#else

#define PatPut(wingl,x,y,patnum) \
			WinGLPut(wingl,x,y,patnum,256,WinGLDrawDAR,0)
#define PatZoomHPut(wingl,x,y,patnum,zoom) \
			WinGLPut(wingl,x,y,patnum,zoom,WinGLDrawDAR_Zx,0)
#define PatWavePut(wingl,x,y,patnum,len,amp,ph ) \
			WinGLWavePut(wingl,x,y,patnum,256,len,amp,ph,WinGLDrawDAR,0)
#define PatZoomHWavePut(wingl,x,y,patnum,xzoom,len,amp,ph ) \
			WinGLWavePut(wingl,x,y,patnum,xzoom,len,amp,ph,WinGLDrawDAR_Zx,0)
#define PatVibraPut(wingl,x,y,patnum,len,amp,ph ) \
			WinGLVibraPut(wingl,x,y,patnum,256,len,ph,WinGLDrawDAR,0)
#define PatZoomHVibraPut(wingl,x,y,patnum,xzoom,len,amp,ph ) \
			WinGLVibraPut(wingl,x,y,patnum,xzoom,len,ph,WinGLDrawDAR_Zx,0)
#define PatZoomVPut(wingl,x,y,patnum,zoom) \
			WinGLZoomVPut(wingl,x,y,patnum,256,zoom,WinGLDrawDAR, 0)
#define PatZoomPut(wingl,x,y,patnum,xzoom,yzoom) \
			WinGLZoomVPut(wingl,x,y,patnum,xzoom,yzoom,WinGLDrawDAR_Zx,0)

#define RopPut(wingl,x,y,patnum,rop) \
			WinGLPut(wingl,x,y,patnum,256,WinGLDrawDAR_Rop,rop)
#define RopZoomHPut(wingl,x,y,patnum,zoom) \
			WinGLPut(wingl,x,y,patnum,zoom,WinGLDrawDAR_Rop_Zx,rop)
#define RopWavePut(wingl,x,y,patnum,len,amp,ph,rop ) \
			WinGLWavePut(wingl,x,y,patnum,256,len,amp,ph,WinGLDrawDAR_Rop,rop)
#define RopZoomHWavePut(wingl,x,y,patnum,xzoom,len,amp,ph,rop ) \
			WinGLWavePut(wingl,x,y,patnum,xzoom,len,amp,ph,WinGLDrawDAR_Rop,rop)
#define RopVibraPut(wingl,x,y,patnum,len,amp,ph,rop ) \
			WinGLVibraPut(wingl,x,y,patnum,256,len,ph,WinGLDrawDAR_Rop,rop)
#define RopZoomHVibraPut(wingl,x,y,patnum,xzoom,len,amp,ph,rop ) \
			WinGLVibraPut(wingl,x,y,patnum,xzoom,len,ph,WinGLDrawDAR_Rop,rop)
#define RopZoomVPut(wingl,x,y,patnum,zoom,rop ) \
			WinGLZoomVPut(wingl,x,y,patnum,256,zoom,WinGLDRawDAR_Rop,rop)
#define RopZoomPut(wingl,x,y,patnum,xzoom,yzoom) \
			WinGLZoomVPut(wingl,x,y,patnum,xzoom,yzoom,WinGLDrawDAR_Rop_Zx,rop)

#endif

/* for backward compatibility... */
#define SuperPut(wingl,x,y,patnum)                PatPut(wingl,x,y,patnum)
#define OverPut(wingl,x,y,patnum)                 PatPut(wingl,x,y,patnum)
#define SuperWavePut(wingl,x,y,patnum,len,amp,ph) PatWavePut(wingl,x,y,patnum,len,amp,ph)
#define OverWavePut(wingl,x,y,patnum,len,amp,ph)  PatWavePut(wingl,x,y,patnum,len,amp,ph)
#define SuperZoomVPut(wingl,x,y,patnum,zoom)      PatZoomVPut(wingl,x,y,patnum,zoom)
#define OverZoomVPut(wingl,x,y,patnum,zoom)       PatZoomVPut(wingl,x,y,patnum,zoom)

void WINGLAPI SuperRotoZoomPut( LPWINGL wingl, int drawx, int drawy, int patnum,
								int cx, int cy, int rot, int dist ) ;

#define WinGLOrigin(wingl,x,y) ((wingl)->ox=(x),(wingl)->oy=(y))
#define WinGLWindowSize(wingl,x,y) ((wingl)->wx=(x),(wingl)->wy=(y))


#ifdef  __cplusplus
class WINGL {
#else
struct WINGL {
#endif
	BITMAPINFOHEADER Header;
	RGBQUAD aColors[256];         /* pbge[ũRs[ */
	HBITMAP gbmOldMonoBitmap;
#ifdef  __cplusplus
public:
#endif
	int dx,dy ;                   /* WINGLrbg}bv(DIB)̑傫(pixel) */
	long Orientation;             /* DIB̕(1=bottomup, -1=topdown */
	int widthBytes;               /* DIB1linẽAhX */
	int lineGapBytes;             /* DIB1linẽAhX(bottomupȂ畉) */
	void far * pBuffer;           /* DIBC[W̐擪AhX */
	long dTopBuffer;              /* DIBC[W̍pixel(0,0)pBufferoffsetAhX */
	unsigned char TransparentColor;
	HDC Buffer;        /* `HDCBWinGWin32pĂȂNULL */
	RECT rectClip;     /* `Nbvg */
	int ox,oy ;        /* WinGLPaint̍JnW */
	int wx,wy ;        /* WinGLPaint̓]傫(DIBłpixel) */
	int zoom ;         /* WinGLPaint̔{(0=1/2, 1={..) */
	HWND hwnd;
#if WINGL32
	void * pDDSurface; /* DirectDrawSurfaceێp|C^ */
	void * pDDPalette;
	void * pDibBuffer;	/* DIBC[W̃obNAbv */
	HDC hdcDib;			/* DIBSectionHDC̃obNAbv */
	int LockCount;
#endif
	DWORD checkword;

#ifdef __cplusplus
	WINGL() { WinGLInit(this); }
	WINGL(HWND hwnd) { WinGLInitEx(this, hwnd); }
	~WINGL() { if ( checkword ) WinGLEnd(this); }
	int Width() const { return dx; }
	int Height() const { return dy ; }
	int WindowWidth() const { return wx; }
	int WindowHeight() const { return wy; }
	int WidthBytes() const { return widthBytes; }
	int LineGapBytes() const { return lineGapBytes; }
	BOOL Lock() { return WinGLLock(this); }
	void Unlock() { WinGLUnlock(this); }
	BOOL Lock2(LPWGLLOCK2 lock) { return WinGLLock2(lock, this); }
	void Unlock2(LPWGLLOCK2 ) { WinGLUnlock(this); }
	HDC GetDC() { return WinGLGetDC(this); }
	void ReleaseDC() { WinGLReleaseDC(this); }
	BITMAPINFOHEADER * getHeader() { return &Header; }
	const RGBQUAD* getColorTable() const { return aColors; }
	void Paint( HDC hdc, int hx=0, int hy=0 ) const { WinGLPaint(this,hdc,hx,hy); }
	void BitBlt( HDC dest, int destx, int desty, int width, int height, int srcx = 0, int srcy = 0 ) const {
		WinGLBitBlt(dest, destx, desty, width, height, this, srcx, srcy );
	}
	void BltTo( LPCWINGL dest, int destx, int desty, int width, int height, int srcx = 0, int srcy = 0 ) const {
		WinGLBlt(dest, destx, desty, width, height, this, srcx, srcy );
	}

	char far * TopAddress() const { return (char FAR *)pBuffer + (unsigned)dTopBuffer ; }
	char far * DotAddress(int x, int y) const { return TopAddress()+(y)*LineGapBytes()+(x); }
	void far * getBuffer() const { return pBuffer; }

	void Size(int dx, int dy, int patnum, HPALETTE& phpalApp) {
		WinGLSize( this, dx, dy, patnum, &phpalApp ) ;
	}
	void Size(int dx, int dy, int patnum ) {
		WinGLSize( this, dx, dy, patnum, 0 ) ;
	}
	void Origin(int newx, int newy) {
		WinGLOrigin(this, newx,newy) ;
	}
	void WindowSize(int width, int height) {
		WinGLWindowSize(this,width,height);
	}
	void Clear(int fillcolor=0) {
		WinGLClear(this,fillcolor);
	}
	void FillRect(const RECT FAR & rect, int fillcolor=0) {
		WinGLFillRect(this, &rect, fillcolor);
	}
	void Zoom(int newzoom) {
		zoom = newzoom ;
	}
	void getClipRect( RECT * r ) const {
		*r = rectClip;
	}
	void setClipRect( const RECT& r ) {
		rectClip = r;
	}

	// drawing pattern

	void PatPut(int x,int y, int patnum) {
		WinGLPut(this,x,y,patnum,256,WinGLDrawDAR,0);
	}
	void ZoomHPut(int x,int y, int patnum, int zoom) {
		::PatZoomHPut(this,x,y,patnum,zoom);
	}
	void RopPut(int x,int y, int patnum, WINGLROP rop) {
		WinGLPut(this,x,y,patnum,256,WinGLDrawDAR_Rop,rop);
	}
	void RopZoomHPut(int x,int y, int patnum, int zoom, WINGLROP rop) {
    	WinGLPut(this,x,y,patnum,zoom,WinGLDrawDAR_Rop_Zx,rop);
	}

	void WavePut(int x, int y, int patnum, int len, char amp, int ph ) {
		::PatWavePut(this,x,y,patnum,len,amp,ph);
	}
	void ZoomHWavePut(int x,int y, int patnum, int zoom, int len, char amp, int ph) {
		::PatZoomHWavePut(this,x,y,patnum,zoom,len,amp,ph);
	}
	void RopWavePut( int x, int y, int patnum, int len, char amp, int ph, WINGLROP rop ) {
		WinGLWavePut(this,x,y,patnum,256,len,amp,ph,WinGLDrawDAR_Rop,rop);
	}
	void RopZoomHWavePut(int x,int y, int patnum, int zoom, int len, char amp, int ph, WINGLROP rop ) {
		WinGLWavePut(this,x,y,patnum,zoom,len,amp,ph,WinGLDrawDAR_Rop_Zx,rop);
	}

	void VibraPut(int x, int y, int patnum, int len, int ph ) {
		::PatVibraPut(this,x,y,patnum,len,ph);
	}
	void ZoomHVibraPut(int x,int y, int patnum, int zoom, int len, int ph) {
		::PatZoomHVibraPut(this,x,y,patnum,zoom,len,ph);
	}
	void RopVibraPut( int x, int y, int patnum, int len, int ph, WINGLROP rop ) {
    	WinGLVibraPut(this,x,y,patnum,256,len,ph,WinGLDrawDAR_Rop,rop);
	}
	void RopZoomHVibraPut(int x,int y, int patnum, int zoom, int len, int ph, WINGLROP rop ) {
    	WinGLVibraPut(this,x,y,patnum,zoom,len,ph,WinGLDrawDAR_Rop_Zx,rop);
	}

	void ZoomVPut(int x,int y, int patnum, int zoom) {
		::PatZoomVPut(this,x,y,patnum,zoom);
	}
	void ZoomPut(int x,int y, int patnum, int xzoom, int yzoom) {
		::PatZoomPut(this,x,y,patnum,xzoom,yzoom);
	}
	void ZoomPut(int x,int y, int patnum, int zoom ) {
		::PatZoomPut(this,x,y,patnum,zoom,zoom);
	}
	void RopZoomVPut(int x,int y, int patnum, int zoom, WINGLROP rop) {
		WinGLZoomVPut(this,x,y,patnum,256,zoom,WinGLDrawDAR_Rop,rop);
	}
	void RopZoomPut(int x,int y, int patnum, int xzoom, int yzoom, WINGLROP rop) {
		WinGLZoomVPut(this,x,y,patnum,xzoom,yzoom,WinGLDrawDAR_Rop_Zx,rop);
	}
	void RopZoomPut(int x,int y, int patnum, int zoom, WINGLROP rop) {
		WinGLZoomVPut(this,x,y,patnum,zoom,zoom,WinGLDrawDAR_Rop_Zx,rop);
	}

	void Draw(LPCWGLDRAWSTRUCT dst) {
		PatDraw(this,dst);
	}
	BOOL Bound(LPCWGLDRAWSTRUCT dst, LPRECT bound) {
		return PatDrawBound(this,dst,bound);
	}
	BOOL Backup( LPRECT rect, LPWGLBACKUPSTRUCT bs ) {
		return WinGLBackup(this,rect,bs);
	}
	BOOL Restore( LPWGLBACKUPSTRUCT bs, WORD flags = WGLRESTOREEX_FREE|WGLRESTOREEX_RESTORE ) {
		return WinGLRestoreEx(this,bs,flags);
	}

# if WINGL32
	void SuperRotoZoomPut( int x, int y, int patnum, int cx, int cy, int rot, int dist ) {
		::SuperRotoZoomPut(this,x,y,patnum,cx,cy,rot,dist);
	}
# endif
#endif
};

#define VALID_WINGL(lpwingl) ((lpwingl) && (LPWINGL)((lpwingl)->checkword) == (lpwingl))

/* Joy Stick */
#define WINGL_MAX_LOCALKEY 8
enum WINGL_KEYS {
	WINGLKEY_UP1 = 0,WINGLKEY_UP2,WINGLKEY_UP3,
	WINGLKEY_DOWN1,WINGLKEY_DOWN2,WINGLKEY_DOWN3,
	WINGLKEY_LEFT1,WINGLKEY_LEFT2,WINGLKEY_LEFT3,
	WINGLKEY_RIGHT1,WINGLKEY_RIGHT2,WINGLKEY_RIGHT3,
	WINGLKEY_TRIGA1,WINGLKEY_TRIGA2,WINGLKEY_TRIGA3,
	WINGLKEY_TRIGB1,WINGLKEY_TRIGB2,WINGLKEY_TRIGB3,
	WINGLKEY_TRIGC1,WINGLKEY_TRIGC2,WINGLKEY_TRIGC3,
	WINGLKEY_TRIGD1,WINGLKEY_TRIGD2,WINGLKEY_TRIGD3,
	WINGLKEY_TRIGE1,WINGLKEY_TRIGE2,WINGLKEY_TRIGE3,
	WINGLKEY_TRIGF1,WINGLKEY_TRIGF2,WINGLKEY_TRIGF3,
	WINGLKEY_TRIGG1,WINGLKEY_TRIGG2,WINGLKEY_TRIGG3,
	WINGLKEY_TRIGH1,WINGLKEY_TRIGH2,WINGLKEY_TRIGH3,
	WINGLKEY_TRIGI1,WINGLKEY_TRIGI2,WINGLKEY_TRIGI3,
	WINGLKEY_TRIGJ1,WINGLKEY_TRIGJ2,WINGLKEY_TRIGJ3,

	WINGLKEY_MAX
};
typedef struct WINGLINPUTSTATE {
	DWORD press;
	int x1, y1, x2, y2 ;
	int x1max, y1max, x2max, y2max;
} WINGLINPUTSTATE;
typedef struct WINGLINPUTSTATE FAR * LPWINGLINPUTSTATE;

typedef unsigned HWINGLINPUT ;

#define HWINGLKEY_1P    0
#define HWINGLKEY_2P1   1
#define HWINGLKEY_2P2   2


HWINGLINPUT WINGLAPI WinGLCreateInput(void) ;
BOOL WINGLAPI WinGLAssignInput(HWINGLINPUT hkey, unsigned keynum, WORD value ) ;
int WINGLAPI WinGLGetAssignInput(HWINGLINPUT assignNum, unsigned keynum );
BOOL WINGLAPI WinGLAssignStick(HWINGLINPUT assignNum, WORD useStick );
WORD WINGLAPI WinGLGetAssignStick(HWINGLINPUT assignNum );
DWORD WINGLAPI WinGLCaptureInput(HWINGLINPUT hkey, LPWINGLINPUTSTATE stat) ;

#define STICK_TRIG1_SHIFT  4 /* TRIG1܂łshift */

#define STICK_UP     1
#define STICK_DOWN   2
#define STICK_LEFT   4
#define STICK_RIGHT  8
#define STICK_TRIG1  0x0010
#define STICK_TRIG2  0x0020
#define STICK_TRIG3  0x0040
#define STICK_TRIG4  0x0080
#define STICK_TRIG5  0x0100
#define STICK_TRIG6  0x0200
#define STICK_TRIG7  0x0400
#define STICK_TRIG8  0x0800
#define STICK_TRIG9  0x1000
#define STICK_TRIG10 0x2000
#define STICK_ESC    0x8000


/* for oldies.. */
typedef struct WINGLSTICKKEYASSIGN WINGLSTICKKEYASSIGN ;
struct WINGLSTICKKEYASSIGN {
	int up;
	int down;
	int left;
	int right;
	int trig1, trig2, trig3, trig4;
} ;
extern WINGLSTICKKEYASSIGN WinGLStickKeyAssign ;

unsigned WINGLAPI GetStickDigital(void) ;

/* Miscellaneous */
extern int SinTable8[256+64] ;

/* WaveMix DLL filename */
extern LPCSTR WinGLWaveMixName;

/* WAVEo͌` */
typedef enum WAVEMODE_T {
	WAVEMODE_NOWAVE = -1,
	WAVEMODE_NOINIT,
	WAVEMODE_SINGLEWAVE,
	WAVEMODE_WAVEMIX,
    WAVEMODE_DIRECTSOUND,
} WAVEMODE_T;

#define WINGLWAVE_MAX   32

WAVEMODE_T WINGLAPI WinGLWaveInit(HINSTANCE hinst, HWND hwnd);    /* ŏɈꔭ   */
void WINGLAPI WinGLWaveActivate(BOOL f);              /* WM_ACTIVATEŌĂ*/
void WINGLAPI WinGLWavePump(void);                    /* d̑O   */
BOOL WINGLAPI WinGLWaveLoadEx(LPCSTR resname, BOOL is_file, int num, int max_simul); /* WAVǂݍ */
BOOL WINGLAPI WinGLWaveExist(int num);                /* ݔ         */
BOOL WINGLAPI WinGLWavePanEx(int num, long pan,int index);        /* Pan(DirectSound̂)             */
BOOL WINGLAPI WinGLWaveVolumeEx(int num, LONG volume,int index);        /* Volume(DirectSound̂)             */
#define WAVEFLAG_LOOP 1
int WINGLAPI WinGLWavePlayEx(int num, DWORD flags); /* Ȃ炷     */
void WINGLAPI WinGLWaveStopEx(int num, int index);                 /* ~߂           */
void WINGLAPI WinGLWaveFree(int num);                 /* WAV          */
void WINGLAPI WinGLWaveEnd(void);                      /* ɂ */
BOOL WINGLAPI IsWinGLWavePlayingEx(int num, int index);            /* Ă邩? (DirectSound̂) */
void WINGLAPI WinGLWaveSetFrequency(int num, int index, DWORD Hz);  /* Đg̕ύX */
DWORD WINGLAPI WinGLWaveGetFrequency(int num, int index);  /* Đg̎擾 */

#define WinGLWaveLoad(name, num)  WinGLWaveLoadEx(name,FALSE,num,-1)
#define WinGLWaveLoad2(name, is_file, num)   WinGLWaveLoadEx(name,is_file,num,-1)
#define WinGLWavePlay(n) WinGLWavePlayEx(n,0)
#define WinGLWaveStop(n) WinGLWaveStopEx(n,-1)
#define WinGLWavePan(n,p) WinGLWavePanEx(n,p,-1)
#define IsWinGLWavePlaying(n) IsWinGLWavePlayingEx(n,-1)


#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
inline int PatEntry(const char * name, int tcolor=-1) {
	return PatEntryName(name,tcolor);
}
inline int PatEntry(int id, int tc=-1) {
	return PatEntryID(id,tc);
}
inline int PatEntry(const char * name,int xs,int ys,int tc=-1) {
	return PatSliceEntryName(name,xs,ys,tc);
}
inline int PatEntry(int id,int xs,int ys,int tc=-1) {
	return PatSliceEntryID(id,xs,ys,tc);
}
inline int PatSliceEntry(const char * name,int xs,int ys,int tc=-1) {
	return PatSliceEntryName(name,xs,ys,tc);
}
inline int PatSliceEntry(int id,int xs,int ys,int tc=-1) {
	return PatSliceEntryID(id,xs,ys,tc);
}

inline int Sin8(int angle) {
	return SinTable8[angle & 0xff] ;
}
inline int Cos8(int angle) {
	return SinTable8[(angle & 0xff)+64] ;
}
#else
# define PatEntry(name)				PatEntryName(name)
# define PatSliceEntry(name,xs,ys)  PatSliceEntryName(name,xs,ys)
# define Sin8(angle)                SinTable8[(angle) & 0xff]
# define Cos8(angle)                SinTable8[((angle) & 0xff)+64]
#endif

#endif                     /* _INC_WINGL */
