// WinGL L1 0.11e
//
// WinGL𗘗pPȃvO\[X(DAR)
// $Header: /WinGL/SIMPLE/simple2.cpp 5     97/02/01 7:10 Koizuka $
//
#include <string.h>
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#pragma hdrstop
#include "WinGL.h"
#include "utils.h"
#include "game.h"
#include "simple.h"
#include "simple2a.dah"
#define DAR_SIMPLE2B_BASE DAR_SIMPLE2A_TOTAL
#include "simple2b.dah"

// pattern numbers
//
#define DAR_ARROW 0
#define DAR_BALL (DAR_SIMPLE2B_BASE+0)
#define DAR_BACK (DAR_SIMPLE2B_BASE+1)

#define NUM_SCENE 2

//
// local class..
//
struct CHARACTER {
	int x,y ;
	int patnum ;
} ;


//
// class derrived GApp
//
class SimpleApp : public GApp {
public:
	SimpleApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw) ;
} ;

//
// class derrived GGameWindow
//
class SimpleWindow : public GGameWindow {
	WINGL Canvas;           // `
	GInputObject Input;     // ͑u
	GInputObject Input2;     // ͑u2

	enum TGameState { GS_TITLE, GS_GAME } GameState ;
	CHARACTER MyChar ;      // LN^
	int patPause ;          // 'Pause'
	int patCopyright ;
	BOOL bFullscreen;
	GROP shadow_rop;
	int scene;

public:
	BOOL FullScreenMode(BOOL full);
	static int SIZEX, SIZEY ;
	static const int MOVE_STEP;
	static const int TIMEOUT;

	static char * getClassName() {
		// Windows"WindowNX"ԂB
		//
		return "Simple2Window";
	}
	static char * getMenuName() {
		// menu\[XԂBmenuȂȂNULL
		//
		return NULL;
	}

	static BOOL RegisterClass() {
		return Register(
			getClassName(),
			LoadCursor(NULL,IDC_ARROW),	            // }EXJ[\(ʏ)
			NULL,	                                // }EXJ[\(ANeBu)̓iV 
			LoadIcon(MainApp->getInstance(),"AppIcon"),   // icon
			getMenuName(),                          // menu name
			0, // (HBRUSH)(COLOR_WINDOW + 1),       // wiuV, 0ȂiV
			// LwiuV́AAvP[VEBhEŜhƂ 0 ɂB 
			0                                       // class style
		);
	}

private:
	//
	void GameStart() ;
	void LoadScene() ;

	void TitleGameProc(HDC) ;
	void InGameProc(HDC hdc) ;


	// override function..
	virtual LRESULT OnCommand(short wNotifyCode, short wId, HWND hwndCtl) ;
	virtual void OnPaint(HDC hdc) ;

	virtual void OnKeyDown( int wVKey, DWORD ) ;

	virtual void OnPause(int lastpause) ;
	virtual BOOL OnPeriod(HDC hdc, UINT drop) ;

	virtual void OnCursorChange();
	virtual void OnRButtonDown( WPARAM fwKey, WORD x, WORD y ) ;
	virtual LRESULT OnWindowPosChanging(LPWINDOWPOS lpwp) ;

public:
	SimpleWindow( int x, int y, HWND hwndParent = 0) ;
} ;

//
// Implementation...
//
 int SimpleWindow::SIZEX = 400;                // `ʂ̑傫
 int SimpleWindow::SIZEY = 300;

const int SimpleWindow::MOVE_STEP = 7;              // ړP
#define MOVE_STEP2 1

const int SimpleWindow::TIMEOUT = 25 ;				// b40̕`

void SimpleWindow::LoadScene() {
	switch ( scene ) {
	case 0:
		PatEntryDARFile( DAR_SIMPLE2B_BASE, DAR_SIMPLE2B_TOTAL, "simple2b.DAR" );
		break;
	default:
		PatEntryDARFile( DAR_SIMPLE2B_BASE, DAR_SIMPLE2B_TOTAL, "simple2c.DAR" );
		break;
	}
	shadow_rop.Translucent( PatColors(DAR_SIMPLE2B_BASE), 0,0, 30 ) ;
}

void SimpleWindow::GameStart() {
	MyChar.x = SIZEX / 2 ;
	MyChar.y = SIZEY / 2 ;
	MyChar.patnum = DAR_BALL ;
	GameState = GS_GAME ;
}

// Q[CłȂƂɂԂĂ΂鏈ꍇ
void SimpleWindow::TitleGameProc(HDC) {
}

// Q[ĈƂɂԂĂ΂鏈
void SimpleWindow::InGameProc(HDC hdc ) {
	int x = MyChar.x ;
	int y = MyChar.y ;

	GInputState stick(Input);	// XeBbN(L[)ǂ
	if ( stick.press() & (STICK_TRIG2|STICK_TRIG9) ) {
		// start button
		OnRButtonDown(0,0,0);
	}
	GInputState stick2(Input2);	// XeBbN(L[)ǂ
	// LN^𓮂

	if ( stick.left() ) {  // ..
		x -= MOVE_STEP;
	}
	if ( stick2.left() ) {
		x -= MOVE_STEP2;
	}
	if ( stick.right()  ) { // E..
		x += MOVE_STEP;
	}
	if ( stick2.right()  ) { // E..
		x += MOVE_STEP2;
	}
	if ( stick.up() ) { // ..
		y -= MOVE_STEP ;
	}
	if ( stick2.up() ) { // ..
		y -= MOVE_STEP2 ;
	}
	if ( stick.down() ) { // ..
		y += MOVE_STEP ;
	}
	if ( stick2.down() ) { // ..
		y += MOVE_STEP2 ;
	}

	// E̍s␳
	if ( x < 0 )
		x = 0;
	else if ( x >= SIZEX )
		x = SIZEX - 1;
	// ㉺B
	if ( y < 0 )
		y = 0 ;
	else if ( y >= SIZEY )
		y = SIZEY-1 ;

	// LN^̈ʒuɔf
	MyChar.x = x ;
	MyChar.y = y ;

	// ̈ړI`悵悤

	// Swi`
	WGLDRAWSTRUCT dst;
	dst.flags = 0;
	dst.patnum = DAR_BACK;
	for ( int iy = 0 ; iy < SIZEY ; iy += PatSizeY(DAR_BACK) ) {
		for ( int ix = 0 ; ix < SIZEX ; ix += PatSizeX(DAR_BACK) ) {
			dst.x = ix;
			dst.y = iy;
			Canvas.Draw( &dst );
		}
	}

	// LN^`
	PatOrigin(MyChar.patnum, (short)(PatSizeX(MyChar.patnum)/2), (short)(PatSizeY(MyChar.patnum)/2) );
	int wx = MyChar.x;
	int wy = MyChar.y;
	dst.patnum = MyChar.patnum;
	static int zoom = 256;

	int f = WDS_ZOOMX|WDS_ZOOMY;
	if ( GetAsyncKeyState(VK_LBUTTON) & 0x8000 ) {
		// }EX{^Ă4{܂ő傫ȂĂ䂭 /
		if ( zoom < 256*4 ) {
			zoom += 16;
		}
	} else {
		// }EX{^𗣂ĂԁA{܂ŏȂĂ䂭 /
		if ( zoom > 256 ) {
			zoom -= 16;
		} else {
			f = 0;
		}
	}
	dst.zoomx = dst.zoomy = zoom;

	// e 
	dst.x = wx + 8;
	dst.y = wy + 16;
	dst.flags = f|WDS_ROP0;
	dst.rop = shadow_rop;
	Canvas.Draw( &dst );

	// {
	dst.flags = f;
	dst.x = wx;
	dst.y = wy;
	Canvas.Draw( &dst );

	if ( patCopyright >= 0 ) {
		// ""
		dst.flags = 0;
		dst.x = Canvas.Width() - PatSizeX(patCopyright);
		dst.y = Canvas.Height() - PatSizeY(patCopyright);
		dst.patnum = patCopyright;
		Canvas.Draw( &dst );
	}

	// }EXJ[\Oŕ`
	if ( GetCursor() == 0 ) { // }EXJ[\Ă邱ƂmF̏
		POINT pt;
		GetCursorPos(&pt);
		ScreenToClient(&pt);

		// WinGL{␳
		int z = Canvas.zoom * 2;
		if ( z == 0 ) z = 1;
		pt.x = pt.x * 2 / z;
		pt.y = pt.y * 2 / z;
		//
		dst.x = pt.x + 12;
		dst.y = pt.y + 24;
		dst.rop = shadow_rop;
		dst.zoomx = dst.zoomy = 192;
		dst.flags = WDS_ROP0|WDS_ZOOMX|WDS_ZOOMY;
		dst.patnum = DAR_ARROW;
		Canvas.Draw( &dst );

		dst.x = pt.x ;
		dst.y = pt.y ;
		dst.flags = WDS_NORMAL;
		dst.patnum = DAR_ARROW;
		Canvas.Draw( &dst );

		// ̂ƂɈʒuJ[\ʒuɊ
		if ( pt.x > MyChar.x )
			MyChar.x += 3;
		else if ( pt.x < MyChar.x )
			MyChar.x -= 2;
		if ( pt.y > MyChar.y )
			MyChar.y += 3;
		else if ( pt.y < MyChar.y )
			MyChar.y -= 2;
		// ̂悤ɁA+-̒l1炷ƁAړI̒n_ɂƂɈUĈ肷̂
		// @BIł()
	}
	// ʂ֓]
	Canvas.Paint(hdc);
} // InGameProc

// IɌĂяo //
// ̎́AStartPeriod()Ŏw肳B
// ̃vȌꍇ TIMEOUT ɐݒ肳Ă鎞(~bP)ŌĂ΂B
BOOL SimpleWindow::OnPeriod(HDC hdc, UINT) {
	switch (GameState) {
	case GS_TITLE:
		TitleGameProc(hdc);
		break;
	case GS_GAME:
		InGameProc(hdc);
	  break;
	}
	return TRUE;
}

// j[IꂽȂ //
LRESULT SimpleWindow::OnCommand(short, short wId, HWND ) {
	switch(wId) {
	case MENU_ABOUT:
		MainApp->AboutBox( MAKEINTRESOURCE(IDD_ABOUT), getHWND() );
		break;
	}
	return 0L;
}


// ق̃EBhEɉBĂꂽƂp̕` //
// ͉Kv͂ȂB
void SimpleWindow::OnPaint(HDC hdc) {
	Canvas.Paint(hdc,0,0);
}

// |[Y/Ԃ̕ω //
void SimpleWindow::OnPause(int lastpause) {
	if ( (lastpause ^ GetPause() ) & 2 ) {
		if ( GetPause() & 2 ) {
			// |[Y //
			//Canvas.Clear(0) ;    // black
			int pat = patPause ;
			Canvas.PatPut( (Canvas.Width() - PatSizeX(pat))/2, (Canvas.Height() - PatSizeY(pat))/2, pat );
			InvalidateRect(0, 0);
		} else {
			// ĊJ //
		}
	}
}

// J[\ω
void SimpleWindow::OnCursorChange() {
	if ( GetCursor() ) {
		// J[\̂ŁAOJ[\
		HDC hdc = GetDC();
		if (hpal && !__WinGLNoSelectPalette)
			SelectPalette(hdc,hpal,FALSE);
		RealizePalette(hdc);
		OnPeriod(hdc,0); /* ̒ŎOJ[\ʍXVs */
		ReleaseDC(hdc);
	}
}

// }EXE{^ꂽ
void SimpleWindow::OnRButtonDown( WPARAM , WORD , WORD  ) {
	++scene;
	if ( scene >= NUM_SCENE )
		scene = 0;

	LoadScene();

	/* pbgύXɉʂɎcĜh߁A񍕂ł߂ */
	/* ۂɂ͍łKv͂ȂAʃpbgŉʂ܂Ă
	 * Ȃ炸ɍςނ */
	Canvas.Clear(PAL_BLACK); /* Uł */
	HDC hdc = GetDC();
	Canvas.Paint(hdc,0,0);        /* ʂɕ\ */
	ReleaseDC(hdc);

	/* pbg؂ւ */
	DeleteObject(hpal);            /* Âpbg폜 */
	Canvas.Size(SIZEX, SIZEY, DAR_SIMPLE2B_BASE, hpal) ;  /* Vpbg蓖Ă */
}

// L[ꂽ //
void SimpleWindow::OnKeyDown( int wVKey, DWORD ) {
	switch ( wVKey ) {
	case VK_F4:
		FullScreenMode( !bFullscreen );
		break;

	case VK_F3:
	case VK_ESCAPE :
		// F3, ESCL[Ń|[Y/ĊJ //
		SetPause(GetPause() == 0);
	}
}

//
// p^[Ƃēo^
//
// :
//   hdc   CreateCompatibleDC(0)ō쐬A\tHgSelectObjectHDC
//   text  
//   color  0`255ŐFw肷
// 
int WINGLAPI CreateTextPat( HDC hdc, LPCSTR text, int color ) {
	SIZE size;
	int patnum;
#if WINGL32
	if ( !GetTextExtentPoint32(hdc, text, lstrlen(text), &size ) )
#endif
	  if ( !GetTextExtentPoint(hdc, text, lstrlen(text), &size ) )
		return -1;

	WGLLOCK2 lock;
	patnum = PatAlloc2(&lock, WinGLPatNum, size.cx, size.cy, NULL, PAL_BLACK /*h*/, PAL_BLACK /**/ );
	if ( patnum >= 0 ) {
		TextDraw2( &lock, hdc, 0, 0, text, color );
		PatUnlock2( &lock, patnum );
	}
	return patnum;
}

//
// Sʃ[hON/OFF
//
BOOL SimpleWindow::FullScreenMode(BOOL full) {
	if ( full ) {
		SIZEX = 640;
		SIZEY = 480;
		Canvas.zoom = 1;
		Canvas.Size(SIZEX,SIZEY, 0);
		
		// EBhE̕`̈̑傫ݒ
		//
		if ( WinGLScreenMode(&Canvas, WGL_FULLSCREEN|WGL_TEST) ) {
			// LvV
			SetStyle( GetStyle() & ~WS_CAPTION );
			if ( WinGLScreenMode(&Canvas, WGL_FULLSCREEN) ) {
				bFullscreen = TRUE;
				return TRUE; /*  */
			}
		}
#if 0
		// tXN[Ɠ傫̑ɂꍇ
		SetClientSize(SIZEX,SIZEY);
		bFullscreen = TRUE;
		return TRUE;
#endif
	}

	// EBhEw肵ꍇ, уtXN[sꍇ

	// EBhE[hɂ
	//
	WinGLScreenMode(&Canvas, WGL_WINDOW);

	SIZEX = 400;
	SIZEY = 300;
	Canvas.zoom = 1;
	Canvas.Size(SIZEX,SIZEY, 0);

	// LvVt
	SetStyle( GetStyle() | WS_CAPTION );

	// Window[hɂĂAWindow̕`̈̑傫ݒ肷
	// ~~~~~~~~~~~~~~~~~~~~~~
	SetClientSize(SIZEX,SIZEY);
	bFullscreen = FALSE;
	return FALSE;
}

LRESULT SimpleWindow::OnWindowPosChanging(LPWINDOWPOS lpwp) {
	// tXN[̊ԁAEBhËړ֎~
	if ( bFullscreen ) {
		if ( !(lpwp->flags & 0x8000) ) // ACRȊȌꍇɂ̂ݎ /
			lpwp->flags |= SWP_NOMOVE;
	}
	return GGameWindow::OnWindowPosChanging(lpwp);
}

//
// Window쐬
//
SimpleWindow::SimpleWindow( int x, int y, HWND hwndParent) :
 GameState(GS_TITLE), Input(GInputObject::Template2P1), Input2(GInputObject::Template2P2), patPause(-1), patCopyright(-1),
 GGameWindow( "WinGL Multi-DAR Sample", getClassName(), 
 WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX, x,y,
 CW_USEDEFAULT,0, hwndParent), Canvas(getHWND()) {

	if ( isOk() ) {
		// DAR[h
		scene = 0;
		LoadScene();

		// zVRAM̏
		//
		Canvas.Size(SIZEX, SIZEY, DAR_SIMPLE2B_BASE, hpal) ;
		Canvas.Clear(0) ;    // black

		// ̓o^
		//
		HDC hdc = CreateCompatibleDC(0);
		HFONT hlastfont = (HFONT)SelectObject(hdc, CreateFont(24,0,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_MODERN | 4 /*TrueType*/, "" ));
		patPause = CreateTextPat( hdc, "ꎞ~", PAL_WHITE );

		DeleteObject( SelectObject(hdc, CreateFont(20,0,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_ROMAN | 4 /*TrueType*/, "" )));
		patCopyright = CreateTextPat( hdc, "NbNŃY[,ENbNDAR؂ւ", DAR_ORANGE );

		DeleteObject( SelectObject(hdc, hlastfont ) );
		DeleteDC(hdc);

		// VXej[Aboutǉ
		//
		GMenu menu(GetSystemMenu(FALSE));
		menu.AppendSeparator();
		menu.AppendString(MENU_ABOUT, "About...");

		// Jn̂߂̐ݒ菈ł
		GameStart();
	}
}

//
// SimpleApp Implementation
//
SimpleApp::SimpleApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw)
 : GApp(hInst,hPrev,szCmdLine,sw) {

	isok = FALSE;
	if ( !hPrev ) {
		if ( !SimpleWindow::RegisterClass() )
			return;
	}

	//
	// N̏̓RR
	// sAreturn Ηǂ
	//
	// : ܂CreateWindowĂȂ̂ŁAEBhEɊ֘AƂ
	//         SimpleWindow::SimpleWindowłĂ
	//

	if ( PatEntryDARFile( 0, DAR_SIMPLE2A_TOTAL, "simple2a.DAR" ) < DAR_SIMPLE2A_TOTAL ) {
		return;
	}

	// ̂
	isok = TRUE;
}

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR szCmdLine, int sw) {
	// AvP[V
	SimpleApp App(hInst,hPrev,szCmdLine,sw);
	if ( !App.isOk() ) { // 玸s
		//
		// Ȃɕse؂CJ
		//
		MessageBox(0, "NɎs܂B", 0, MB_ICONSTOP|MB_OK );
		return FALSE;
	}

	// EBhEJ
	SimpleWindow Window(CW_USEDEFAULT, 0 );
	if ( !Window.isOk() ) { // 玸s
		//
		// CJCJ
		//
		MessageBox(0, "EBhEJȂ悤", 0, MB_ICONSTOP|MB_OK );
		return FALSE;
	}

	// ĕ\ON!
#if 0
	// ȂtXN[ɂꍇ(łȂ΃EBhE\)
	if ( !Window.FullScreenMode( TRUE ) ) {
		Window.Show(sw);
	}
#else
	// ʂɃEBhEԂŋNꍇ
	Window.FullScreenMode( FALSE ); // EBhȆ傫ݒ
	Window.Show(sw);
#endif

	Window.StartPeriod( SimpleWindow::TIMEOUT, 0 ) ;  // ɂOnPeriodԂĂ΂悤ɂȂ

	// ēJnB
	return App.MessageLoop();
}
